/*  F2_FUPLIB30.h                                                      */
/*  Header fuer SIMULINK Erweiterungs-Blockbibliothek FUP Version 3.0  */

#include "F2_NUTZER30.h"            /* Anpassung an den Anwendungsfall */

#ifndef MATLAB_MEX_FILE    /* zur Echtzeitkodeerzeugung mit RealLink32 */
 #include <stdlib.h>
 #include <stdio.h>
 #include <math.h>
 #include <tmwtypes.h>
 #ifndef RT
   #define RT               /* zur Bibliothekserzeugung mit WATCOM IDE */
 #endif
#endif

#ifndef C_MEX_FUNCTION
 #include <simstruc.h>
#else
 #include <mex.h>
#endif
 
/* Teil 1: Symbolische Konstanten des Systems                          */

#define FNRMIN 1      /* kleinste zulssige Funktionsplannummer: >=1!  */
#define FNRMAX 9      /* grte zulssige Funktionsplannummer:   <=9!  */
#define BNRMIN 1      /* kleinste zulssige Blocknummer: >=1!          */
#define BNRMAX 9999   /* grte zulssige Blocknummer:   <=9999!       */
#define TESTER 9999   /* Testkodierung, es mu gelten: Tester>ANPAZU   */
#if (ANZFNR<FNRMIN || ANZFNR>FNRMAX)
    #error F2_NUTZER*.h definiert falsche Konstante ANZFNR!
#endif
#if (TESTER<=ANPAZU)
    #error F2_NUTZER*.h definiert mehr als "Tester" parallele Zustnde!
#endif
#define Z6L    15           /* Lnge des Trennstrings z6 in FUPI_KB*.c */
#define ZKLMAX 31        /* zulssige Zeichenkettenlnge fr Blcke KB */
#define KBGMAX 100 /* Kodierte Boolsche Gleichung: Zeichenkettenlnge  */
                   /*                              fr Blcke FVZ      */

/* Teil 2: Fehlertexte                                                 */

/* Teil 2a - C-Funktionen fr FUPA und FUPU                            */
#define FT01 "FINI_X0BlZu erkennt ANZFNR-berlauffehler - siehe F2_Nutzer30.h\
\n--> bei Forderung FNRMAX>9 bitte Rcksprache halten!"
#define FT02 "UNION_ erkennt ANPAZU-berlauffehler - siehe F2_Nutzer30.h!"
#define FT03 "DEAKT_ erkennt fatalen Widerspruch!"
#define FT04 "F2_BlZu liefert undefinierten Fehlerkode!"
#define FT05 "FINI_WeVo erkennt ANZVAR-berlauffehler - siehe F2_Nutzer30.h!"
#define FT06 "FINI_KB erkennt ANZVAR-berlauffehler - siehe F2_Nutzer30.h!"
#define FT07 "F2_FeZu erkennt berlagerte Fehlerbearbeitung!"
#define FT08 "F2_FeZu liefert undefinierten Fehlerkode!"
#define FT09 "\n Fehler am Eingang eines AZ-Blocks: Mehrere Eingnge aktiv!!!"

/* Teil 2b - S-Funktionen                                              */
#define FT50 "FUPA_V30: Falsche Kodierung erkannt!"
#define FT51 "FUPU_V30: Falsche Kodierung erkannt!"

/* Teil 2c - MEX-Funktionen                                            */
#define FT60 "FUPI_V30: Drei Eingangsargumente erwartet!"
#define FT61 "FUPI_V30: Falsche Kodierung erkannt!"

/* Teil 2d - C-Funktionen fr FUPI                                     */
#define FT70 "Z_INIT Fehler: Falsche Dimension Eingangsargumente 2 und/oder 3!"
#define FT71 "Z_INIT Fehler: Zwei Ausgangsargumente sind definiert!"
#define FT72 "Z_INIT Fehler: Eingangsargument 1 ist als Vektor 1*2 definiert!"
#define FT73 "Unzulssige Eingabe fr Blocknummer!"
#define FT74 "Unzulssige Eingabe fr FUP-Nummer!"
#define FT75 "FUV_INIT Fehler: Falsche Dimension Eingangsargumente 2 und/oder 3!"
#define FT76 "FUV_INIT Fehler: Ein Ausgangsargument ist definiert!"
#define FT77 "FUV_INIT Fehler: Eingangsargument 1 ist als Vektor 1*x definiert!"
#define FT78 "KB_INIT Fehler: Nicht leerer String ohne Semikolon entdeckt!"
#define FT79 "KB_INIT Fehler: Ungleiche Anzahl von '=' und';' entdeckt!"
#define FT80 "KB_INIT Fehler: In dieser Version sind Klammern unzulssig!"
#define FT81 "KB_INIT Fehler: MATLAB Variablennamen-Konvention verletzt!"
#define FT82 "KB_INIT Fehler: Unzulssige Zahlenwertvereinbarung entdeckt!"
#define FT83 "KB_INIT Fehler: Falsche Dimension Eingangsargument 3!"
#define FT84 "KB_INIT Fehler: Zwei Ausgangsargumente sind definiert!"
#define FT85 "KB_INIT Fehler: Eingnge 1 und 2 sind als Zeilenvektor definiert!"
#define FT86 "KB_INIT erkennt ZKLMAX-Fehler fr einen Namen oder Wert!"
#define FT87 "ZF_INIT Fehler: Falsche Dimension Eingangsargumente 2 und/oder 3!"
#define FT88 "ZF_INIT Fehler: Zwei Ausgangsargumente  sind definiert!"
#define FT89 "ZF_INIT Fehler: Eingangsargument 1 ist als Vektor 1*2 definiert!"
#define FT90 "FVZ_INIT Fehler: Unzulssige Kodierung in Boolscher Gleichung!"
#define FT91 "FVZ_INIT Fehler: Boolsche Gleichung zu lang - bitte Rcksprache halten!"
#define FT92 "FVZ_INIT Fehler: Unzulssige Blocknummer erkannt!"
#define FT93 "FVZ_INIT Fehler: Falsche Dimension Eingangsargument 3!"
#define FT94 "FVZ_INIT Fehler: Zwei Ausgangsargumente sind definiert!"
#define FT95 "FVZ_INIT Fehler: Falsche Dimension Eingangsargumente 1 / 2: 1*1; 1*x !"
#define FT96 "FVZ_INIT Fehler: Unzulssige FUP-Nummer erkannt!"
#define FT97 "FVZ_INIT Fehler: Boolsche Gleichung ist leer!"
#define FT98 "AZF_INIT Fehler: Falsche Dimension in den Eingangsargumenten 1 / 2 / 3!"
#define FT99 "AZF_INIT Fehler: Zwei Ausgangsargumente sind definiert!"

/* Teil 3: Makros                                                      */

/* UNION_ - Einfgen einer Kodierung in FUPx_ASP bzw. FUPx_RSP         */
/*          Verwendung innerhalb von C-MEX Level 2 S-Funktionen        */
/*          KEINE Speicherung der NEUEN LNGE - wegen for-Scheifen!!!  */
#define UNION_(LAENGE,ADRESSE,KENNUNG) \
        j=0; \
        for (i=0; i<LAENGE; i++) \
            {if (*(ADRESSE+i)==KENNUNG) {j++;} } \
        if (j==0) \
           {if (LAENGE==ANPAZU) \
               {STO_SCH=2; \
                printf("\n\7\7\7" FT02 "\7\7\7\n\n"); \
                abort; /* oder auch "exit" */ } \
            *(ADRESSE+LAENGE)=KENNUNG; \
            LAENGE++; }

/* DEAKT_ - Lschen einer Kodierung in FUPx_RSP und FUPx_ASP           */
/*          Verwendung innerhalb von C-MEX Level 2 S-Funktionen        */
/*          SPEICHERUNG der NEUEN LNGE - Unterschied zu UNION_!!!     */
#define DEAKT_(LAENGE1,ADRESSE1,LAENGE2,ADRESSE2,KENNUNG) \
        j=0; \
        for (i=0; i<LAENGE1; i++) /* RSP durchsuchen */ \
            {if (*(ADRESSE1+i)==KENNUNG) {j++; iSp=i; break; } } \
        if  (j!=0) \
            {*(ADRESSE1+iSp)=*(ADRESSE1+LAENGE1-1); \
             iSp=TESTER; \
             for (i=0; i<LAENGE2; i++) /* ASP durchsuchen */ \
                 {if (*(ADRESSE2+i)==KENNUNG) {iSp=i; break; } } \
             if (iSp==TESTER) \
                {STO_SCH=3; \
                 printf("\n\7\7\7" FT03 "\7\7\7\n\n"); \
                 abort; /* oder auch "exit" */ } \
             *(ADRESSE2+iSp)=*(ADRESSE2+LAENGE2-1); \
             *(ADRESSE1-1)=LAENGE1-1; \
             *(ADRESSE2-1)=LAENGE2-1; }

/* STOPSS - Programmabbruch durch nicht tolerierbaren Fehler            */
/*          Verwendung innerhalb von C-MEX Level 2 S-Funktionen         */
#if REDPRU
#define STOPSS(BEDINGUNG,TEXT) \
        if (BEDINGUNG) \
             {printf("\n\7\7\7" TEXT "\7\7\7\n\n"); \
              abort;  /* oder auch "exit" */ \
              ssSetErrorStatus(S,"\n" TEXT); \
              return; }
#else
#define STOPSS(BEDINGUNG,TEXT)
#endif

/* STOPNS - Programmabbruch durch nicht tolerierbaren Fehler            */
/*          Verwendung innerhalb von C-MEX Level 2 S-Funktionen         */
#if REDPRU
#define STOPNS(BEDINGUNG,TEXT) \
        if (BEDINGUNG) \
             {ssSetErrorStatus(S,"\n" TEXT); \
              STO_SCH=0;\
              return; }
#else
#define STOPNS(BEDINGUNG,TEXT)
#endif

/* STOPKS - Programmabbruch durch nicht tolerierbaren Fehler            */
/*          Verwendung innerhalb von C-MEX Level 2 S-Funktionen         */
#if REDPRU
#define STOPKS(TEXT) \
        ssSetErrorStatus(S,"\n" TEXT); \
        STO_SCH=0;\
        return;
#else
#define STOPKS(TEXT)
#endif

/* STOP_K - Programmabbruch durch nicht tolerierbaren Fehler            */
/*          Verwendung in C-Quellen und C-MEX in Initialisierungsfiles  */
#if REDPRU
#define STOP_K(BEDINGUNG,TEXT,KODE) \
        if (BEDINGUNG) \
             {STO_SCH=KODE; \
              printf("\n\7\7\7" TEXT "\7\7\7\n\n"); \
              abort;  /* oder auch "exit" */ }
#else
#define STOP_K(BEDINGUNG,TEXT,KODE)
#endif

/* STOP_X - Programmabbruch durch nicht tolerierbaren Fehler            */
/*          Verwendung in C-Quellen und C-MEX Initialisierungsfiles     */
#if REDPRU
#define STOP_X(TEXT) \
             {printf("\n\7\7\7" TEXT "\7\7\7\n\n"); \
              abort;  /* oder auch "exit" */ }
#else
#define STOP_X(TEXT)
#endif
