/*function y=FUPA_V30(u)                  ---> FUP Steuer-S-Funktion */

#define S_FUNCTION_NAME FUPA_V30
#define S_FUNCTION_LEVEL 2
#include "F2_EXTABH30.h"

static void mdlInitializeSizes(SimStruct *S)
{   ssSetNumSFcnParams(S, 1);
    if (ssGetNumSFcnParams(S)!=ssGetSFcnParamsCount(S)) return;
    if (!ssSetNumInputPorts(S, 1)) return;
    ssSetInputPortWidth(S, 0, DYNAMICALLY_SIZED);
    ssSetInputPortDirectFeedThrough(S, 0, 1);
    if (!ssSetNumOutputPorts(S, 3)) return;
    ssSetOutputPortWidth(S, 0, DYNAMICALLY_SIZED);        /* Typ II  */
    ssSetOutputPortWidth(S, 1, 1);                        /* Typ I   */
    ssSetOutputPortWidth(S, 2, 1);                        /* Typ III */
    ssSetNumSampleTimes(S, 1);
    ssSetOptions(S, SS_OPTION_EXCEPTION_FREE_CODE); }

static void mdlInitializeSampleTimes(SimStruct *S)
{ ssSetSampleTime(S, 0, INHERITED_SAMPLE_TIME);
  ssSetOffsetTime(S, 0, 0.0); }

static void mdlOutputs(SimStruct *S, int_T tid)
{InputRealPtrsType  u=ssGetInputPortRealSignalPtrs(S,0);
 real_T             *y=ssGetOutputPortRealSignal(S,0);    /* Typ II  */
 real_T             *y1=ssGetOutputPortRealSignal(S,1);   /* Typ I   */
 real_T             *y2=ssGetOutputPortRealSignal(S,2);
 
 double     AW;
 int        c, FN, nInputs, Kode, Offset;

 start: c=*y2+mxGetPr(ssGetSFcnParam(S,0))[0];
 switch(c)
  {case 110: nInputs=ssGetInputPortWidth(S,0);
             F2_BlZu19(u,y1,nInputs);         /* E/A: dyn/1 == Typ I */
             if (STO_SCH!=0) {if       (STO_SCH==2) {STOPKS(FT02);}
                              else {if (STO_SCH==3) {STOPKS(FT03);}
                              else                  {STOPKS(FT04);}}}
             break;
   case 120: F2_BlKo6(y); break;           /* E/A: dyn/-  ---> A-->E */
                  
   case 125: F2_WeVo6(y,y1); break;           /* E/A: 1/1 ---> Typ I */
                      
   case 130: nInputs=ssGetInputPortWidth(S,0);
             F2_FVZ5(u,y1,nInputs); break;    /* E/A: dyn/1 == Typ I */
   case 135: F2_FeZu9(u,y1);                  /* E/A: dyn/1 == Typ I */
             if (STO_SCH!=0) {if       (STO_SCH==2) {STOPKS(FT02);}
                              else {if (STO_SCH==3) {STOPKS(FT03);}
                              else {if (STO_SCH==4) {STOPKS(FT07);}
                              else                  {STOPKS(FT08);}}}}
             break;
   case 160: F2_AnaB11(u,y); break;           /* E/A: 1/8 ---> TypII */

   case 20:  FINI_KB1(u,y);                      /* Offsetberechnung */
             STOPNS(STO_SCH!=0,FT06); *y2=100; goto start;

   case 25:  Kode=*u[0]; AW=*u[1];                /* AW: Typ double! */
             *y=FINI_WeVo1(Kode,AW);             /* Offsetberechnung */
             STOPNS(STO_SCH!=0,FT05); *y2=100; goto start;
   case 30:
   case 60:
   case 10:  FN=*u[0];
             FINI_X0BlZu2(FN);
             STOPNS(STO_SCH!=0,FT01); *y2=100; goto start;
  
   default:  ssSetErrorStatus(S,FT50);
  }  
}

static void mdlTerminate(SimStruct *S){}

#ifdef	MATLAB_MEX_FILE      /* Is this file being compiled as a MEX-file? */
#include "simulink.c"                       /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"               /* Code generation registration function */
#endif
