/*function y=FUPU_V30(u)                  ---> FUP Steuer-S-Funktion */

#define S_FUNCTION_NAME FUPU_V30
#define S_FUNCTION_LEVEL 2
#include "F2_EXTUNA30.h"

static void mdlInitializeSizes(SimStruct *S)
{   ssSetNumSFcnParams(S, 1);
    if (ssGetNumSFcnParams(S)!=ssGetSFcnParamsCount(S)) return;
    if (!ssSetNumInputPorts(S, 1)) return;
    ssSetInputPortWidth(S, 0, DYNAMICALLY_SIZED);
    ssSetInputPortDirectFeedThrough(S, 0, 1);
    if (!ssSetNumOutputPorts(S, 2)) return;
    ssSetOutputPortWidth(S, 0, DYNAMICALLY_SIZED);        /* Typ II  */
    ssSetOutputPortWidth(S, 1, 1);                        /* Typ I   */
    ssSetNumSampleTimes(S, 1);
    ssSetOptions(S, SS_OPTION_EXCEPTION_FREE_CODE); }

static void mdlInitializeSampleTimes(SimStruct *S)
{ ssSetSampleTime(S, 0, INHERITED_SAMPLE_TIME);
  ssSetOffsetTime(S, 0, 0.0); }

static void mdlOutputs(SimStruct *S, int_T tid)
{InputRealPtrsType  u=ssGetInputPortRealSignalPtrs(S,0);
 real_T             *y=ssGetOutputPortRealSignal(S,0);    /* Typ II  */
 real_T             *y1=ssGetOutputPortRealSignal(S,1);   /* Typ I   */
 
 int        c, nInputs;

 c=mxGetPr(ssGetSFcnParam(S,0))[0];
 switch(c)
  {case 140: nInputs=ssGetInputPortWidth(S,0);
             F2_AZ9(u,y1,nInputs);            /* E/A: dyn/1 == Typ I */
             if (STO_SCH2!=0)
                {ssSetErrorStatus(S,"\n" FT09); STO_SCH2=0; return; }
             break;
   
   case 150: nInputs=ssGetInputPortWidth(S,0);
             F2_PZ10(u,y,nInputs);         /* E/A: dyn/dyn == Typ II */
             break;

   case 170: nInputs=ssGetInputPortWidth(S,0);
             F2_Anz9(u,y,nInputs); /* E/A: dyn/dyn|arith ---> Typ II */
             break;

   default:  ssSetErrorStatus(S,FT51);
  }  
}

static void mdlTerminate(SimStruct *S){}

#ifdef	MATLAB_MEX_FILE      /* Is this file being compiled as a MEX-file? */
#include "simulink.c"                       /* MEX-file interface mechanism */
#else
#include "cg_sfun.h"               /* Code generation registration function */
#endif
