function varargout = FC_SACK(varargin)
% FC_SACK Application M-file for FC_SACK.fig
%    FIG = FC_SACK launch FC_SACK GUI.
%    FC_SACK('callback_name', ...) invoke the named callback.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

if nargin == 7  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor')); %Systemfarben
	handles = guihandles(fig); %Generierung der "handles"-Struktur fr Callbacks
	guidata(fig, handles);
	if nargout > 0 varargout{1} = fig;
	end
    handles.xx=varargin{1};
    handles.kob=varargin{2};
    handles.var=varargin{3};
    handles.fez=varargin{4};
    handles.its=varargin{5};
    handles.FUP=varargin{6};       %[FN PrfArt Textausgabe Sackgasse] bergeben
    guidata(fig, handles);         %fr Callbacks speichern
    FName=varargin{7};             %Name des *.mdl Files
    x=length(FName);
    AT='FUP check for FN=0 in x';   %AT='Funktionsplanprfung fr FN=0 in x';
    AT(18)=num2str(handles.FUP(1)); %AT(29)=num2str(handles.FUP(1));   %FN setzen
    AT(23:23+x-1)=FName(1:x);       %AT(34:34+x-1)=FName(1:x);         %Filename
    set(handles.listbox2,'String',AT,'Value',1)
    set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try   [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch disp(lasterr);
	end
end
% --------------------------------------------------------------------
% Callback for pushbutton1 -  "Start" --> Prfung auslsen
% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
set(handles.pushbutton1,'Enable','off')
XX=handles.xx;
FN=handles.FUP(1);
T00='         ';   %Leerzeichen, da TAB nicht verfgbar in listbox
T_0='Step 1: Function Chart analyses, FN = ';
T_1='State block numbers, {ZA,ZX,ZE,ZF} = ';
T_2='Initial state number, ZA = ';
T_3='Error state number, ZF = ';
T_4='Step 2: Check for dead ends';
T_5='This Function Chart features no dead ends.';
T_6='Check completed!';
%T_0='Schritt 1: Analyse von Funktionsplan ';
%T_1='Anzahl der Zustandsblcke {ZA,ZX,ZE,ZF} = ';
%T_2='Zustandsnummer Anfangszustand(ZA) = ';
%T_3='Zustandsnummer Fehlerzustand(ZF) = ';
%T_4='Schritt 2: Prfung auf Sackgassen';
%T_5='Dieser Funktionsplan hat keine Zustandssackgassen.';
%T_6='Prfung abgeschlossen!';
ASCH=[handles.FUP(3)  1  handles.FUP(4)];
                     %ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
                     %ASCH(2)==GUI: 1-Textumleitung von Bildschirm in ANZ
                     %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                     %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN;Typ); 0-SIMULINK-BlockName
if ASCH(1) PER={[T_0 int2str(FN)]}; else PER={}; end %Ausfhrliche Ausgabe?                    
set(handles.listbox1,'String',PER) %Zwischenausgabe
[M,NAZ,NAF,ZOV,SKO,FEH,ANZ]=XX2M04(XX,FN,ASCH);
SBN=length(ZOV);
if isempty(FEH)                                 %XX2M04 liefert keine Fehlermeldung
   if ASCH(1) PER(2,1)={[T00 T_1 int2str(SBN)]};
              PER(3,1)={[T00 T_2 int2str(ZOV(NAZ))]}; end %Ausfhrliche Ausgabe?
   if NAF~=0 if ASCH(1) PER(4,1)={[T00 T_3 int2str(ZOV(NAF))]}; end; end
   if ASCH(1) PER(end+1,1)={T_4}; end              %Ausfhrliche Ausgabe?
   ZM=sum(M');                                     %Zeilensumme<-1 vorhanden?
   if isempty(find(ZM(:)<-1))                      %Keine PxV
      PER(end+1,1)={[T00 T_5]};
      set(handles.listbox1,'String',PER)           %PrfErgebnisAusgabe "Keine PxV"
   else                                            %PxV vorhanden / ZwiAusMgl.
      [M,NAZ,NAF,ZOV,FEH,ANZ]=RELIZU03(M,NAZ,NAF,ZOV,ASCH); %ab RELIZU02 wegen NAF
      if isempty(FEH)                              %NCHSTE ZEILE: ZwiAusMgl.
         if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
         [M,NAZ,NAF,ZOV,FEH,ANZ]=ZUKOM03(M,NAZ,NAF,ZOV,ASCH);%ohne NAZ/NAF nderung
         if isempty(FEH)                           %NCHSTE ZEILE: ZwiAusMgl.
            if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);end
            [BBZ,NUZ,SGZ,FEH,ANZ]=TAZUSA06(M,NAZ,NAF,ZOV,ASCH);
            if isempty(FEH)
               if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
               PER(end+1,1)={T_6};
               set(handles.listbox1,'String',PER)  %PrfErgebnisAusgabe "mit PxV"
            else set(handles.listbox1,'String',FEH); end   %Fehlerausgabe TAZUSA
         else set(handles.listbox1,'String',FEH); end      %Fehlerausgabe ZUKOM
      else set(handles.listbox1,'String',FEH); end; end    %Fehlerausgabe RELIZU
else set(handles.listbox1,'String',FEH)                    %Fehlerausgabe XX2M
end
set(handles.pushbutton1,'Enable','on')
% --------------------------------------------------------------------
% Callback for pushbutton2 - "Abbruch" --> Stop + Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
% --------------------------------------------------------------------
% Callback for pushbutton3 - "Hilfe"
% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
pfad=which('ae_7_6e.htm');
if   isempty(pfad)
     warndlg('File ae_7_6e.htm was not found.','Info:')
else web([pfad '#PM3']);
end
% --------------------------------------------------------------------
% Callback for pushbutton4 - "Ende" --> Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
clear global FupCheck_HDL_FUP_
delete(handles.figure1)
% --------------------------------------------------------------------
% Callback for radiobutton1 - Eine Sackgasse finden
% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
set(handles.radiobutton1,'Value',1)  %gegenseitige Verriegelung
set(handles.radiobutton2,'Value',0)
handles.FUP(4)=1; %  [FN  PrfArt  Textausgabe  Sackgasse]
guidata(handles.figure1, handles);   %speichern
FupCheck_HDL_FUP_(1)=1;
% --------------------------------------------------------------------
% Callback for radiobutton2 - Alle Sackgassen finden
% --------------------------------------------------------------------
function varargout = radiobutton2_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
set(handles.radiobutton1,'Value',0)  %gegenseitige Verriegelung
set(handles.radiobutton2,'Value',1)
handles.FUP(4)=0; %  [FN  PrfArt  Textausgabe  Sackgasse]
guidata(handles.figure1, handles);   %speichern
FupCheck_HDL_FUP_(1)=0;
% --------------------------------------------------------------------
% Callback for listbox1 - Ausgabe der Prfergebnisse
% --------------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
disp('listbox1 Callback not implemented yet.')
% ------------------------------------------------------------
% Callback for the GUI figure CloseRequestFcn property
% ------------------------------------------------------------
function varargout = figure1_CloseRequestFcn(h, eventdata, handles, varargin)
pushbutton4_Callback(h,eventdata,handles)
