function varargout = FC_SYNT(varargin)
% FC_SYNT Application M-file for FC_SYNT.fig
%    FIG = FC_SYNT launch FC_SYNT GUI.
%    FC_SYNT('callback_name', ...) invoke the named callback.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

if nargin == 7  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor')); %Systemfarben
	handles = guihandles(fig); %Generierung der "handles"-Struktur fr Callbacks
	guidata(fig, handles);
	if nargout > 0 varargout{1} = fig;
	end
    handles.xx=varargin{1};
    handles.kob=varargin{2};
    handles.var=varargin{3};
    handles.fez=varargin{4};
    handles.its=varargin{5};
    handles.FUP=varargin{6};   %[FN PrfArt Textausgabe Sackgasse Syntax] bergeben
    guidata(fig, handles);     %fr Callbacks speichern
    FName=varargin{7};         %Name des *.mdl Files
    x=length(FName);
    AT='FUP check for FN=0 in x';   %AT='Funktionsplanprfung fr FN=0 in x';
    AT(18)=num2str(handles.FUP(1)); %AT(29)=num2str(handles.FUP(1));   %FN setzen
    AT(23:23+x-1)=FName(1:x);       %AT(34:34+x-1)=FName(1:x);         %Filename
    set(handles.listbox2,'String',AT,'Value',1)
    set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try   [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch disp(lasterr);
	end
end
% --------------------------------------------------------------------
% Callback for pushbutton1 -  "Start" --> Prfung auslsen
% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
set(handles.pushbutton1,'Enable','off')
XX=handles.xx;
ITS=handles.its;
FN=handles.FUP(1);
T00='         ';   %Leerzeichen, da TAB nicht verfgbar in listbox
T_0='Step 1: Function Chart analyses, FN = ';
T_1='Initial state number, ZA = ';
T_2='Hint: selected FUP devoid of any ZF block!';
T_3='Error state number, ZF = ';
T_4='Step 2: syntax check';
T_8='Abort: selected FUP contains more then one ZF block!';
T_9='Abort: selected FUP contains not just one ZA block!';
%T_2='Hinweis: Ausgewhlter FUP enthlt keinen ZF-Block!';
%T_8='Abbruch: Ausgewhlter FUP enthlt mehr als einen ZF-Block!';
%T_9='Abbruch: Ausgewhlter FUP enthlt nicht genau einen ZA-Block!';
ASCH=[handles.FUP(3)  1  1 handles.FUP(5)];
                     %ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
                     %ASCH(2)==GUI: 1-Textumleitung von Bildschirm in ANZ
                     %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                     %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN;Typ); 0-SIMULINK-BlockName
if ASCH(1) PER={[T_0 int2str(FN)]}; else PER={}; end %Ausfhrliche Ausgabe?                    
zza=find(XX(:,3)==4715&XX(:,7)==FN);    %Zeile von ZA im ausgewhltem FN suchen
if length(zza)==1                       %FUP enthlt genau einen Block ZA
   if ASCH(1) PER(2,1)={[T00 T_1 int2str(XX(zza,6))]}; end %Ausfhrliche Ausgabe?
   zzf=find(XX(:,3)==5105&XX(:,7)==FN); %Zeile von ZF im ausgewhltem FN suchen
   i=length(zzf);
   if i<2 if i==0 zzf=0; if ASCH(1) PER(3,1)={[T00 T_2]}; end%Ausfhrliche Ausgabe?
          else           if ASCH(1) PER(3,1)={[T00 T_3 int2str(XX(zzf,6))]};end;end
   if ASCH(1) PER(4,1)={T_4}; end
   [XX0,FEH,ANZ]=TundS03(XX,zza,zzf,ITS,ASCH);
   if isempty(FEH)
      if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
      set(handles.listbox1,'String',PER)                 %Zwischenausgabe
      [X2,FEH,ANZ]=SYNTAX03(XX0,ASCH);           %mit Sonderfllen (AxV/Z;PxV/Z)
      if isempty(FEH)
         if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);
            set(handles.listbox1,'String',PER)           %Ergebis: fehlerfrei!
         else
            [FEH,ANZ]=SFDEKO01(X2,XX0,ITS,ASCH); %Klartextausgabe der Syntaxfehler
            if isempty(FEH)
               if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
               PER(end+1,1)={'Prfung abgeschlossen!'};
               set(handles.listbox1,'String',PER)            %ERBEGNIS-Fehlerzeilen
            else set(handles.listbox1,'String',FEH); end; end %Fehlerausgabe SFDEKO
      else set(handles.listbox1,'String',FEH); end            %Fehlerausgabe SYNTAX
   else set(handles.listbox1,'String',FEH); end               %Fehlerausgabe TundS
   else FEH={[T00 T_8]}; set(handles.listbox1,'String',FEH); end%Fehlerausgabe zzf
else FEH={[T00 T_9]}; set(handles.listbox1,'String',FEH); end   %Fehlerausgabe zza
set(handles.pushbutton1,'Enable','on')
% --------------------------------------------------------------------
% Callback for pushbutton2 - "Lschen" --> Stop(wie?) + Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
% --------------------------------------------------------------------
% Callback for pushbutton3 - "Hilfe"
% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
pfad=which('ae_7_6e.htm');
if   isempty(pfad)
     warndlg('Das File ae_7_6e.htm wurde nicht gefunden.','Information:')
else web([pfad '#PM2']);
end
% --------------------------------------------------------------------
% Callback for pushbutton4 - "Ende" --> Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
clear global FupCheck_HDL_FUP_
delete(handles.figure1)
% --------------------------------------------------------------------
% Callback for radiobutton1 - Eine Sackgasse finden
% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
set(handles.radiobutton1,'Value',1)  %gegenseitige Verriegelung
set(handles.radiobutton2,'Value',0)
handles.FUP(5)=0; %  [FN  PrfArt  Textausgabe  Sackgasse Syntax]
guidata(handles.figure1, handles);   %speichern
FupCheck_HDL_FUP_(2)=0;              %(1): Sackgasse
% --------------------------------------------------------------------
% Callback for radiobutton2 - Alle Sackgassen finden
% --------------------------------------------------------------------
function varargout = radiobutton2_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
set(handles.radiobutton1,'Value',0)  %gegenseitige Verriegelung
set(handles.radiobutton2,'Value',1)
handles.FUP(5)=1; %  [FN  PrfArt  Textausgabe  Sackgasse Syntax]
guidata(handles.figure1, handles);   %speichern
FupCheck_HDL_FUP_(2)=1;              %(1): Sackgasse
% --------------------------------------------------------------------
% Callback for listbox1 - Ausgabe der Prfergebnisse
% --------------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.listbox1.
disp('listbox1 Callback not implemented yet.')
% ------------------------------------------------------------
% Callback for the GUI figure CloseRequestFcn property
% ------------------------------------------------------------
function varargout = figure1_CloseRequestFcn(h, eventdata, handles, varargin)
pushbutton4_Callback(h,eventdata,handles)
