function varargout = FC_PARA(varargin)
% FC_PARA Application M-file for FC_PARA.fig
%    FIG = FC_PARA launch FC_PARA GUI.
%    FC_PARA('callback_name', ...) invoke the named callback.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

if nargin == 8  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor')); %Systemfarben
	handles = guihandles(fig); %Generierung der "handles"-Struktur fr Callbacks
	guidata(fig, handles);
	if nargout > 0 varargout{1} = fig;
	end
    handles.xx=varargin{1};
    handles.kob=varargin{2};
    handles.var=varargin{3};
    handles.fez=varargin{4};
    handles.its=varargin{5};
    handles.FUP=varargin{6};       %[FN PrfArt Textausgabe Sackgasse Syntax]
    handles.FName=varargin{7};     %Filename: Name des *.mdl Files
    handles.STEU=varargin{8};      %Einstellung aller 7 ParameterPrfschritte
    guidata(fig, handles);         %fr Callbacks speichern
    FName=varargin{7};             %Name des *.mdl Files
    x=length(FName);
    AT='FUP check for FN=0 in x';   %AT='Funktionsplanprfung fr FN=0 in x';
    AT(18)=num2str(handles.FUP(1)); %AT(29)=num2str(handles.FUP(1));   %FN setzen
    AT(23:23+x-1)=FName(1:x);       %AT(34:34+x-1)=FName(1:x);         %Filename
    set(handles.listbox2,'String',AT,'Value',1)
    set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try   [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch disp(lasterr);
	end
end
% --------------------------------------------------------------------
% Callback for pushbutton1 -  "Start" --> Prfung auslsen
% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
set(handles.pushbutton1,'Enable','off')
XX=handles.xx;KOB=handles.kob;VAR=handles.var;FEZ=handles.fez;ITS=handles.its;
FN=handles.FUP(1); FiNa=handles.FName;
T00='         ';   %Leerzeichen, da TAB nicht verfgbar in listbox
T_0='Step 1: Function Chart analyses, FN = ';
T_1='Initial state number, ZA = ';
T_2='Hint: selected FUP devoid of any ZF block!';
T_3='Error state number, ZF = ';
T_4='Step 2: parameter check';
T_7='Abort: selected FUP contains more then one ZF block!';
T_8='Abort: selected FUP contains not just one ZA block!';
T_9='Abort: operating error - no check selected!';
%T_9='Abbruch: Fehlbedienung - keine Prfaufgabe ausgewhlt!';
ASCH=[handles.FUP(3)  1  1  handles.FUP(5)];
                     %ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
                     %ASCH(2)==GUI: 1-Textumleitung von Bildschirm in ANZ
                     %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                     %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN;Typ); 0-SIMULINK-BlockName
STEU=handles.STEU;   %STEU(1)=1 FN  Prfung (alle FN im FUP gleich?)
                     %STEU(2)=1 ZN  Prfung (alle ZN im FUP verschieden?)
                     %STEU(3)=1 KB  Prfung (alle KB an Zustandsausgang?)
                     %STEU(4)=1 FVZ Prfung (alle FVZ an EX enable?)
                     %STEU(5)=1 FUV Prfung (alle FUV-Var mit KB Sender?)
                     %STEU(6)=1 VAR in KB Prfung (alle KB-Var mit FUV Empfang?)
                     %STEU(7)=1 ZN in FVZ Prfung (alle Zustandsnummern in FVZ?)
if ASCH(1) PER={[T_0 int2str(FN)]}; else PER={}; end %Ausfhrliche Ausgabe?                    
if sum(STEU)~=0      %es wurden Prfaufagben ausgewhlt
zza=find(XX(:,3)==4715&XX(:,7)==FN);    %Zeile von ZA im ausgewhltem FN suchen
if length(zza)==1                       %FUP enthlt genau einen Block ZA
   if ASCH(1) PER(2,1)={[T00 T_1 int2str(XX(zza,6))]}; end %Ausfhrliche Ausgabe?
   zzf=find(XX(:,3)==5105&XX(:,7)==FN); %Zeile von ZF im ausgewhltem FN suchen
   i=length(zzf);
   if i<2 if i==0 zzf=0; if ASCH(1) PER(3,1)={[T00 T_2]}; end %Ausgabe ausfhrlich?
          else           if ASCH(1) PER(3,1)={[T00 T_3 int2str(XX(zzf,6))]};end;end
   if ASCH(1) PER(4,1)={T_4}; end
   [XX0,FEH,ANZ,XXn]=TundS03(XX,zza,zzf,ITS,ASCH);
   if isempty(FEH)
      if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
      set(handles.listbox1,'String',PER)                 %Zwischenausgabe
      if zzf zzf=find(XX0(:,3)==5105); end   %Zeile von ZF in XX0 fr FN suchen
      [FEH,ANZ]=HauPar01(XX,XX0,XXn,KOB,VAR,FEZ,ITS,FN,FiNa,zzf,STEU,ASCH);
      if isempty(FEH)
         z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);
         set(handles.listbox1,'String',PER)                     %ERGEBNIS-Ausgabe
      else set(handles.listbox1,'String',FEH); end            %Fehlerausgabe HauPar
   else set(handles.listbox1,'String',FEH); end               %Fehlerausgabe TundS
   else FEH={[T00 T_7]};set(handles.listbox1,'String',FEH); end %Fehlerausgabe zzf
else FEH={[T00 T_8]}; set(handles.listbox1,'String',FEH); end   %Fehlerausgabe zza
else FEH={[T00 T_9]}; set(handles.listbox1,'String',FEH); end   %Fehlerausgabe STEU
set(handles.pushbutton1,'Enable','on')
% --------------------------------------------------------------------
% Callback for pushbutton2 - "Lschen" --> Stop + Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
% --------------------------------------------------------------------
% Callback for pushbutton3 - "Hilfe"
% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
pfad=which('ae_7_6e.htm');
if   isempty(pfad)
     warndlg('Das File ae_7_6e.htm wurde nicht gefunden.','Information:')
else web([pfad '#PM1']);
end
% --------------------------------------------------------------------
% Callback for pushbutton4 - "Ende" --> Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
clear global FupCheck_HDL_FUP_
delete(handles.figure1)
% ------------------------------------------------------------
% Callback for the GUI figure CloseRequestFcn property
% ------------------------------------------------------------
function varargout = figure1_CloseRequestFcn(h, eventdata, handles, varargin)
pushbutton4_Callback(h,eventdata,handles)
% --------------------------------------------------------------------
% Callback for checkbox1 - FN Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox1_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox1,'Value',1)
     handles.STEU(1)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(3)=1;
else set(handles.checkbox1,'Value',0)
     handles.STEU(1)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(3)=0; end
% --------------------------------------------------------------------
% Callback for checkbox2 - ZN Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox2_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox2,'Value',1)
     handles.STEU(2)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(4)=1;    
else set(handles.checkbox2,'Value',0)
     handles.STEU(2)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(4)=0; end
% --------------------------------------------------------------------
% Callback for checkbox3 - KB Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox3_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox3,'Value',1)
     handles.STEU(3)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(5)=1;
else set(handles.checkbox3,'Value',0)
     handles.STEU(3)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(5)=0; end
% --------------------------------------------------------------------
% Callback for checkbox4 - FVZ Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox4_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox4,'Value',1)
     handles.STEU(4)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(6)=1;
else set(handles.checkbox4,'Value',0)
     handles.STEU(4)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(6)=0; end
% --------------------------------------------------------------------
% Callback for checkbox5 - FUV Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox5_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox5,'Value',1)
     handles.STEU(5)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(7)=1;
else set(handles.checkbox5,'Value',0)
     handles.STEU(5)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(7)=0; end
% --------------------------------------------------------------------
% Callback for checkbox6 - VAR in KB Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox6_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox6,'Value',1)
     handles.STEU(6)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(8)=1;
else set(handles.checkbox6,'Value',0)
     handles.STEU(6)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(8)=0; end
% --------------------------------------------------------------------
% Callback for checkbox7 - ZN in FVZ Prfschritt
% --------------------------------------------------------------------
function varargout = checkbox7_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
if (get(h,'Value') == get(h,'Max'))
     set(handles.checkbox7,'Value',1)
     handles.STEU(7)=1;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(9)=1;
else set(handles.checkbox7,'Value',0)
     handles.STEU(7)=0;
     guidata(handles.figure1, handles);   %speichern
     FupCheck_HDL_FUP_(9)=0; end
