function varargout = FC_VOLL(varargin)
% FC_VOLL Application M-file for FC_VOLL.fig
%    FIG = FC_VOLL launch FC_VOLL GUI.
%    FC_VOLL('callback_name', ...) invoke the named callback.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

if nargin == 8  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor')); %Systemfarben
	handles = guihandles(fig); %Generierung der "handles"-Struktur fr Callbacks
	guidata(fig, handles);
	if nargout > 0 varargout{1} = fig;
	end
    handles.xx=varargin{1};
    handles.kob=varargin{2};
    handles.var=varargin{3};
    handles.fez=varargin{4};
    handles.its=varargin{5};
    handles.FUP=varargin{6};       %[FN PrfArt Textausgabe Sackgasse Syntax]
    handles.FName=varargin{7};     %Filename: Name des *.mdl Files
    guidata(fig, handles);         %fr Callbacks speichern
    FName=varargin{7};             %Name des *.mdl Files
    x=length(FName);
    AT='FUP check for FN=0 in x';   %AT='Funktionsplanprfung fr FN=0 in x';
    AT(18)=num2str(handles.FUP(1)); %AT(29)=num2str(handles.FUP(1));   %FN setzen
    AT(23:23+x-1)=FName(1:x);       %AT(34:34+x-1)=FName(1:x);         %Filename
    set(handles.listbox2,'String',AT,'Value',1)
    set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try   [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch disp(lasterr);
	end
end
% --------------------------------------------------------------------
% Callback for pushbutton1 -  "Start" --> Prfung auslsen
% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
set(handles.pushbutton1,'Enable','off')
XX=handles.xx;KOB=handles.kob;VAR=handles.var;FEZ=handles.fez;ITS=handles.its;
FN=handles.FUP(1); FiNa=handles.FName;
T00='         ';   %Leerzeichen, da TAB nicht verfgbar in listbox
T_0='Step 1: Function Chart analyses, FN = ';
T_1='Initial state number, ZA = ';
T_2='Hint: selected FUP devoid of any ZF block!';
T_3='Error state number, ZF = ';
T_4={' '; 'Step 2: parameter check';};
T_5={'Step 3: syntax check'; ' ';};
T_5a={'--> Syntax check completed!'; ' ';};
T_6={'Step 4: Check for dead ends'; ' ';};
T_7='State block numbers, {ZA,ZX,ZE,ZF} = ';
T_8='This Function Chart features no dead ends.';
T_9={'--> Check for dead ends completed!'; ' ';};
T_10={'Step 5: Check for loops'; ' ';};
T_11='Check for loops completed!';
T_12a='All in all were ';
T_12b=' normal sequence and ';
T_12c=' error sequence loops detected.';
T_13={'Detected normal sequence loops all in all:'};
T_14={'Detected error sequence loops all in all:'};
T_16='Stop of syntax check and abort of complete check!';
T_17='Abort: selected FUP contains more then one ZF block!';
T_18='Abort: selected FUP contains not just one ZA block!';

ASCH=[handles.FUP(3)  1  1  1]; %(1)-flexibel von Hauptfenster; sonst hier fest
                     %ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
                     %ASCH(2)==GUI: 1-Textumleitung von Bildschirm in ANZ
                     %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                     %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN;Typ); 0-SIMULINK-BlockName
STEU=[1 1 1 1 1 1 1]; %FC_VOLL: hier fest vorgegeben
if ASCH(1) PER={[T_0 int2str(FN)]}; else PER={}; end %Ausfhrliche Ausgabe?                    
zza=find(XX(:,3)==4715&XX(:,7)==FN);    %Zeile von ZA im ausgewhltem FN suchen
if length(zza)==1                       %FUP enthlt genau einen Block ZA
 if ASCH(1) PER(2,1)={[T00 T_1 int2str(XX(zza,6))]}; end %Ausfhrliche Ausgabe?
 zzf=find(XX(:,3)==5105&XX(:,7)==FN); %Zeile von ZF im ausgewhltem FN suchen
 i=length(zzf);
 if i<2 if i==0 zzf=0; if ASCH(1) PER(3,1)={[T00 T_2]}; end %Ausfhrliche Ausgabe?
        else           if ASCH(1) PER(3,1)={[T00 T_3 int2str(XX(zzf,6))]};end;end
  if ASCH(1) PER(4:5,1)=T_4(1:2,1); end
  [XX0,FEH,ANZ,XXn]=TundS03(XX,zza,zzf,ITS,ASCH);             % >>>TundS<<<
  if isempty(FEH)
   if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end%ZwiAusMgl.
   if zzf zzf=find(XX0(:,3)==5105); end          %Zeile von ZF in XX0 fr FN suchen
   [FEH,ANZ]=HauPar01(XX,XX0,XXn,KOB,VAR,FEZ,ITS,FN,FiNa,zzf,STEU,ASCH);%>>HauPar<<
   if isempty(FEH)
    z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);              %ZwiAusMgl.
    set(handles.listbox1,'String',PER)                         %ERGEBNIS-1-Ausgabe
    if ASCH(1) PER(end+1:end+2,1)=T_5(1:2,1); end
    set(handles.listbox1,'String',PER)                         %Textausgabe
    [X2,FEH,ANZ]=SYNTAX03(XX0,ASCH);                           % >>>SYNTAX<<<
    if isempty(FEH)                                 %mit Sonderfllen (AxV/Z;PxV/Z)
     if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);
      set(handles.listbox1,'String',PER)                    %Ergebis-2a-fehlerfrei!
      PER(end+1:end+2,1)=T_5a(1:2,1);                       %ENDE-Meldung Syntax
      if ASCH(1) PER(end+1:end+2,1)=T_6(1:2,1); end
      [Mo,NAZo,NAFo,ZOVo,SKO,FEH,ANZ]=XX2M04(XX,FN,ASCH);     % >>>XX2M<<<
      SBN=length(ZOVo);
      if isempty(FEH)                             %XX2M liefert keine Fehlermeldung
       if ASCH(1) PER(end+1,1)={[T00 T_7 int2str(SBN)]}; end %Ausfhrliche Ausgabe?
       ZM=sum(Mo');                                     %Zeilensumme<-1 vorhanden?
       if isempty(find(ZM(:)<-1))                       %Keine PxV
        PER(end+1,1)={T_8};
        set(handles.listbox1,'String',PER)            %Ergebnis-3a-i.O. "Keine PxV"
       else                                           %PxV vorhanden / ZwiAusMgl.
        [M,NAZ,NAF,ZOV,FEH,ANZ]=RELIZU03(Mo,NAZo,NAFo,ZOVo,ASCH);%>>>RELIZU<<<
        if isempty(FEH)                               %NCHSTE ZEILE: ZwiAusMg.
         if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
         [M,NAZ,NAF,ZOV,FEH,ANZ]=ZUKOM03(M,NAZ,NAF,ZOV,ASCH); % >>>ZUKOM<<<
         if isempty(FEH)                              %NCHSTE ZEILE: ZwiAusMg.
          if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1);end
          [BBZ,NUZ,SGZ,FEH,ANZ]=TAZUSA06(M,NAZ,NAF,ZOV,ASCH); % >>>TAZUSA<<<
          if isempty(FEH)
           if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
            set(handles.listbox1,'String',PER)             %Ergebnis-3b "mit PxV"
          else set(handles.listbox1,'String',FEH); end     %Fehlerausgabe TAZUSA
         else set(handles.listbox1,'String',FEH); end      %Fehlerausgabe ZUKOM
        else set(handles.listbox1,'String',FEH); end; end  %Fehlerausgabe RELIZU
       PER(end+1:end+2,1)=T_9(1:2,1);                      %ENDE-Meldung Sackgasse
       if ASCH(1) PER(end+1:end+2,1)=T_10(1:2,1); end
       set(handles.listbox1,'String',PER)                     %Zwischenausgabe
       [PFM1,E1,PFM2,E2,FEH,ANZ1]=TEDERU02(Mo,NAZo,NAFo,ZOVo,SKO,ASCH);%>>TEDERU<<
       if isempty(FEH)          %***Beginn: Ausgabe Rckfhrpfade
        ANZ={};                 %mit ANZ1 Reihenfolgetausch ermglichen
        if ASCH(1)              %Anzeige aller gefundenen Rckfhrschleifen
         jn=length(E1); jf=length(E2);
         ANZ(1,1)={[T_12a num2str(jn) T_12b num2str(jf) T_12c]};
         ANZ(2,1)=T_13;
         for i=1:jn
          E=find(PFM1(i,:)~=0);
          L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
          for ii=1:AgZ x1=1+(ii-1)*Anz;x2=x1+Anz-1;if x2>L2 x2=L2;end%Anf/EndProZei
              if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
              ANZ(end+1,1)={[t0 num2str(PFM1(i,x1:x2))]}; end; end%Anzeige
         if jf ANZ(end+1,1)=T_14; end
         for i=1:jf
          E=find(PFM2(i,:)~=0);
          L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
          for ii=1:AgZ x1=1+(ii-1)*Anz;x2=x1+Anz-1;if x2>L2 x2=L2;end%Anf/EndProZei
              if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
              ANZ(end+1,1)={[t0 num2str(PFM2(i,x1:x2))]}; end; end;%Anzeige
        end                 %***Ende: Ausgabe Rckfhrpfade
        ANZ=[ANZ; ANZ1];    %Reihenfolge Hinweis/Anzeige und Warnung/Fehler ndern
        if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
        PER(end+1,1)={T_11};
        set(handles.listbox1,'String',PER)
       else set(handles.listbox1,'String',FEH); end           %Fehlerausgabe TEDERU
      else set(handles.listbox1,'String',FEH); end            %Fehlerausgabe XX2M   
     else [FEH,ANZ]=SFDEKO01(X2,XX0,ITS,ASCH);    %Klartextausgabe der Syntaxfehler
     if isempty(FEH)                                          %>>>SFDEKO<<<
      if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
      PER(end+1,1)={T_16}; set(handles.listbox1,'String',PER) %Erg.-2b-Fehlerzeilen
     else set(handles.listbox1,'String',FEH); end; end        %Fehlerausgabe SFDEKO
    else set(handles.listbox1,'String',FEH); end              %Fehlerausgabe SYNTAX
   else set(handles.listbox1,'String',FEH); end               %Fehlerausgabe HauPar
  else set(handles.listbox1,'String',FEH); end                %Fehlerausgabe TundS
 else FEH={[T00 T_17]};set(handles.listbox1,'String',FEH); end%Fehlerausgabe zzf
else FEH={[T00 T_18]}; set(handles.listbox1,'String',FEH); end%Fehlerausgabe zza
set(handles.pushbutton1,'Enable','on')
% --------------------------------------------------------------------
% Callback for pushbutton2 - "Lschen" --> Stop + Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
% --------------------------------------------------------------------
% Callback for pushbutton3 - "Hilfe"
% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
pfad=which('ae_7_6e.htm');
if   isempty(pfad)
     warndlg('Das File ae_7_6e.htm wurde nicht gefunden.','Information:')
else web([pfad '#PM5']);
end
% --------------------------------------------------------------------
% Callback for pushbutton4 - "Ende" --> Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
global FupCheck_HDL_FUP_
clear global FupCheck_HDL_FUP_
delete(handles.figure1)
% ------------------------------------------------------------
% Callback for the GUI figure CloseRequestFcn property
% ------------------------------------------------------------
function varargout = figure1_CloseRequestFcn(h, eventdata, handles, varargin)
pushbutton4_Callback(h,eventdata,handles)
