function varargout = FC_WEIT(varargin)
% FC_WEIT Application M-file for FC_WEIT.fig
%    FIG = FC_WEIT launch FC_WEIT GUI.
%    FC_WEIT('callback_name', ...) invoke the named callback.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

if nargin == 7  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor')); %Systemfarben
	handles = guihandles(fig); %Generierung der "handles"-Struktur fr Callbacks
	guidata(fig, handles);
	if nargout > 0 varargout{1} = fig;
	end
    handles.xx=varargin{1};
    handles.kob=varargin{2};
    handles.var=varargin{3};
    handles.fez=varargin{4};
    handles.its=varargin{5};
    handles.FUP=varargin{6};       %[FN PrfArt Textausgabe Sackgasse] bergeben
    guidata(fig, handles);         %fr Callbacks speichern
    FName=varargin{7};             %Name des *.mdl Files
    x=length(FName);
    AT='FUP check for FN=0 in x';   %AT='Funktionsplanprfung fr FN=0 in x';
    AT(18)=num2str(handles.FUP(1)); %AT(29)=num2str(handles.FUP(1));   %FN setzen
    AT(23:23+x-1)=FName(1:x);       %AT(34:34+x-1)=FName(1:x);         %Filename
    set(handles.listbox2,'String',AT,'Value',1)
    set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try   [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch disp(lasterr);
	end
end
% --------------------------------------------------------------------
% Callback for pushbutton1 -  "Start" --> Prfung auslsen
% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
set(handles.pushbutton1,'Enable','off')
XX=handles.xx;
FN=handles.FUP(1);
T00='         ';   %Leerzeichen, da TAB nicht verfgbar in listbox
T_0='Step 1: Function Chart analyses, FN = ';
T_1='State block numbers, {ZA,ZX,ZE,ZF} = ';
T_2='Initial state number, ZA = ';
T_3='Error state number, ZF = ';
T_4='Step 2: Check for loops';
T_5='Check completed!';
T_6a='All in all were ';
T_6b=' normal sequence and ';
T_6c=' error sequence loops detected.';
T_7={'Detected normal sequence loops all in all:'};
T_8={'Detected error sequence loops all in all:'};
%T_6a='Insgesamt wurden ';
%T_6b=' Normalablauf- und ';
%T_6c=' Fehlerablauf-Rckfhrschleifen ermittelt.';
%T_7={'Ermittelte Rckfhrschleifen Normalablauf insgesamt:'};
%T_8={'Ermittelte Rckfhrschleifen Fehlerablauf insgesamt:'};

ASCH=[handles.FUP(3)  1];
                     %ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
                     %ASCH(2)==GUI: 1-Textumleitung von Bildschirm in ANZ
if ASCH(1) PER={[T_0 int2str(FN)]}; else PER={}; end %Ausfhrliche Ausgabe?                  
set(handles.listbox1,'String',PER) %Zwischenausgabe
[M,NAZ,NAF,ZOV,SKO,FEH,ANZ1]=XX2M04(XX,FN,ASCH);
SBN=length(ZOV);
if isempty(FEH)                                   %XX2M liefert keine Fehlermeldung
   if ASCH(1) PER(2,1)={[T00 T_1 int2str(SBN)]};
              PER(3,1)={[T00 T_2 int2str(ZOV(NAZ))]}; end
   if NAF~=0 if ASCH(1) PER(4,1)={[T00 T_3 int2str(ZOV(NAF))]}; end, end
   if ASCH(1) PER(end+1,1)={T_4}; end
   [PFM1,E1,PFM2,E2,FEH,ANZ2]=TEDERU02(M,NAZ,NAF,ZOV,SKO,ASCH); %ZwiAusMgl.   
   if isempty(FEH)
      ANZ={};                 %Reihenfolgetausch ermglichen
      if ASCH(1)              %Anzeige aller gefundenen Rckfhrschleifen
      jn=length(E1); jf=length(E2);
      ANZ(1,1)={[T_6a num2str(jn) T_6b num2str(jf) T_6c]};
      ANZ(2,1)=T_7;
      for i=1:jn
          E=find(PFM1(i,:)~=0);
          L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
          for ii=1:AgZ x1=1+(ii-1)*Anz;x2=x1+Anz-1;if x2>L2 x2=L2;end%Anf/EndProZei
              if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
              ANZ(end+1,1)={[t0 num2str(PFM1(i,x1:x2))]}; end; end%Anzeige
      if jf ANZ(end+1,1)=T_8; end
      for i=1:jf
          E=find(PFM2(i,:)~=0);
          L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
          for ii=1:AgZ x1=1+(ii-1)*Anz;x2=x1+Anz-1;if x2>L2 x2=L2;end%Anf/EndProZei
              if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
              ANZ(end+1,1)={[t0 num2str(PFM2(i,x1:x2))]}; end; end;%Anzeige
      end
      ANZ=[ANZ1; ANZ; ANZ2]; %Reihenfolge Hinweis/Anzeige und Warnung/Fehler ndern 
      if ~isempty(ANZ) z=length(ANZ); PER(end+1:end+z,1)=ANZ(1:z,1); end
      PER(end+1,1)={T_5}; set(handles.listbox1,'String',PER)
   else set(handles.listbox1,'String',FEH); end              %Fehlerausgabe TEDERU
else set(handles.listbox1,'String',FEH); end                 %Fehlerausgabe XX2M
set(handles.pushbutton1,'Enable','on')
% --------------------------------------------------------------------
% Callback for pushbutton2 - "Abbruch" --> Stop + Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton2_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','<empty>','Value',[]) %Auswahl rcksetzen
% --------------------------------------------------------------------
% Callback for pushbutton3 - "Hilfe"
% --------------------------------------------------------------------
function varargout = pushbutton3_Callback(h, eventdata, handles, varargin)
pfad=which('ae_7_6e.htm');
if   isempty(pfad)
     warndlg('Das File ae_7_6e.htm wurde nicht gefunden.','Information:')
else web([pfad '#PM4']);
end
% --------------------------------------------------------------------
% Callback for pushbutton4 - "Ende" --> Fenster schlieen
% --------------------------------------------------------------------
function varargout = pushbutton4_Callback(h, eventdata, handles, varargin)
delete(handles.figure1)
% ------------------------------------------------------------
% Callback for the GUI figure CloseRequestFcn property
% ------------------------------------------------------------
function varargout = figure1_CloseRequestFcn(h, eventdata, handles, varargin)
pushbutton4_Callback(h,eventdata,handles)
