function [FEH,ANZ]=HauPar01(XXg,XX0,XXn,KOB,VAR,FEZ,ITS,FN,FiNa,zzf,STEU,ASCH)
%function [FEH,ANZ]=HauPar01(XXg,XX0,XXn,KOB,VAR,FEZ,ITS,FN,FiNa,zzf,STEU,ASCH)
%FEH Cell-String mit Fehlermeldung, wenn ASCH(2)==1 
%ANZ Cell-String-Vektor mit Ausgabetexten, wenn ASCH(1)==1 & ASCH(2)==1
%XXg nach FUPSCAN XX fr gesamtes Projekt (*.mdl File)
%XX0 nach FUPSCAN (XX) ber TundS fr >>>einen<<< ausgewhlten Funktionsplan
%    Matrixzeilenaufbau=[QZN ZIT Skode SNr Tkode BN FN Offset Z_ZIT1 ZSK1 ...]
%XXn nur Normalablauf ohne Fehlerbehandlung nach FUPSCAN (XX) ber TundS
%    fr >>>einen<<< ausgewhlten Funktionsplan
%FN  Nummer des zu prfenden Funktionsplanes
%FiNa Filename mit Endung
%STEU Steuervektor zur Funktionsauswahl in HauPar:
%     Steu(1) = FN  Prfung               Steu(5) = FUV Prfung
%     Steu(2) = ZN  Prfung               Steu(6) = VAR in KB Prfung
%     Steu(3) = KB  Prfung               Steu(7) = ZN in FVZ Prfung
%     Steu(4) = FVZ Prfung
%ASCH Textausgabeschalter ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
%                         ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
%                         ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
%                         ASCH(4)==FoS:  1-FUP-Ausgabe(ZN,FN); 0-SIMULINK-Name

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

TKodeZB=10;  %TKode fr Zustandsblcke
TKodeKB=20;  %TKode fr Kommentarblcke
TKodeFUV=25; %TKode fr FUP_Variablenblock
TKodeFVZ=30; %TKode fr Fehlervorzustand
TKodeEX=80;  %TKode fr Ereignisblock

T_00={'--> Parameter check completed!'; ' ';};
T_01={'No parameter error detected.';...
      '--> Parameter check completed!'; ' ';};
T_11={'1  FN check successfully completed!'};
T_12={'1a Wrong Function Chart number for state blocks as below:'};
T_13=' in: '; T_14=' in: level 0'; T_15=' using X'; T_16=' and FN='; 
                                                    T_17=' instead FN=';
T_21={'2  ZN check successfully completed!'};
T_22={'2a Incorrect multiple use of state number ZN for state blocks as below:'};
T_23=' in: '; T_24=' in: level 0'; T_25=' using F';
                                   T_26=' and state number(ZN)=';
T_30={['3  KB check: project "' FiNa '" devoid of KB blocks.']};
T_31={'3  KB check successfully completed!'};
T_32='3a State block outputs without KB block connection in FN=';
T_35=['3b Wrong connected KB blocks in project "' FiNa '":'];
T_36=' using X'; T_37='/F'; T_38=' in: ';
                            T_39=' in: level 0';
T_40={['4  FVZ check: project "' FiNa '" devoid of FVZ blocks.']};
T_41={['4  FVZ check: Function Chart FN=' num2str(FN) ' devoid of FVZ blocks.']};
T_42={'4  FVZ check successfully completed!'};
T_43={'4h Fatal error: FUP contains FVZ blocks but no ZF block!'};
T_44='4a FVZ blocks not connected to EX blocks switching inputs (eanable):';
T_45=['4b FVZ blocks without accord to state blocks subsequently to EX blocks' ...
                                                                ' regarding FN:'];
T_46='4c FVZ blocks using wrong FN (see other FUP in same project):';
T_47='4d FVZ blocks using incorrect connections to EX blocks in normal sequence:';
T_48=['4e FVZ blocks without immediate connection to EX block enable ' ...
                                                    'subsequently to ZF block :'];
T_49='4f FVZ blocks applying wrong Function Chart number FN:';
T_50={['5  FUV check: project "' FiNa '" devoid of FUV blocks.']};
T_51={['5b Fatal error: project "' FiNa '" contains FUV but no KB blocks.']};
T_52={'5  FUV check successfully completed!'};
T_53='   Hint: project contains ';
T_54=' variables using following names:';
T_55=['5a Definition of variables in FUV blocks with missing pendant ' ... 
                                                  'in KB blocks as a sender:'];
T_56='   Hint: multiple received variables in FUV blocks:';
T_60={['6  VAR in KB check: project "' FiNa '" devoid of KB blocks.']};
T_61={['6b Fatal error: project "' FiNa '" contains KB but no FUV blocks.']};
T_62={'6  VAR in KB check successfully completed!'};
T_63=['6a Definition of variables in KB blocks with missing pendant ' ... 
                                               'in FUV blocks as a receiver:'];
T_64='6c Warning: There are variables which are set one time only in KB blocks:';
T_70={['7  ZN in FVZ check: project "' FiNa '" contains no'];...
       '                      Boolean equations for failure handling.'};
T_71={['7  ZN in FVZ check: Function Chart FN=' num2str(FN) 'contains'];...
       '                      no Boolean equations for failure handling.'};
T_72={'7  ZN in FVZ check successfully completed!'};
T_73={'   Hint: Failure handling includes ';' states using numbers:'};
T_74='7a Missing normal sequence states in failure handling (FVZ blocks):';
T_75='7b Wrong (own) state numbers in failure handling (FVZ) detected:';
T_76='7c Non-existing state numbers in failure handling (FVZ) detected:';
T_90=['4g FVZ blocks which are missed at EX block enable inputs ' ...
                                              'subsequently to ZF block:'];
T_91='Non-identification: check step 4bI!';
T_92='Non-identification: check step 4bII!';
T_93='Non-identification: check step 4bIII!';

FEH={}; ANZ={}; text=[];    %Initialisieren falls keine Rckmeldung erfolgt
if nargin==1                %ohne Vorgabe: Ausgabe aller Rckmeldetexte auf
   ASCH=1; GUI=0; FoS=0;    %Bildschirm freigeben
else GUI=ASCH(2); FoS=ASCH(4); ASCH=ASCH(1);
end                          %Vorbereitung der Prfung:
zei=find(XX0(:,5)==TKodeZB); %alle Zeilen mit Zustandsblcken (TKode=10) finden
ZL=length(zei);              %Anzahl der Zustandsblcke
XX=XX0(zei,:);               %Laufzeitreduzierung bei Suchfunktionen
if STEU(1)                   %Schritt 1: FN Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   zei=find(XX(:,7)~=FN);   %[QZN ZIT Skode SNr Tkode BN FN Offset Z_ZIT1 ZSK1 ...]
   if isempty(zei) if ASCH text=T_11; else text=[]; end
   else text=T_12;
     for i=1:length(zei) z=zei(i);
         [t1,FEH]=BLN(TKodeZB,XX(z,3),XX(z,4),0,GUI,FEH);
      if XX(z,2) t2=[T_13 char(TSN(XX(z,2),ITS))]; else t2=T_14; end %ZIT>0 SS_Pfad
         text{end+1,1}=...
        ['   ' t1 T_15 num2str(XX(z,6)) T_16 num2str(XX(z,7)) T_17 num2str(FN) t2];
     end; end
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(2)                   %Schritt 2: ZN Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   [vek,ze0]=unique(XX(:,6));%alle auftretenden Zustandsnummrn/Zeilenr dieses FUP's
   zei=setdiff(1:ZL,ze0); %Zeilennummern mit ZN-Dopplungen finden (Anzahl=Doppl-1!)
   vek=unique(XX(zei,6)); %Zustandsnummern der ZN-Dopplungen 
   [vek,ze1]=setxor(XX(:,6),vek);%Zustandsnummern/Zeilennr ohne ZN-Dopplungen
   zei=setdiff(1:ZL,ze1);    % >>>Alle<<< Zeilennummern mit ZN-Dopplungen finden
   [i,j]=sort(XX(zei,6));    %betroffene ZN sortieren (ZN/Zeilennr)
   zei=zei(j);               %entsprechende Zeilennummern umordnen
   if isempty(zei) if ASCH text=T_21; else text=[]; end
   else text=T_22;
     for i=1:length(zei) z=zei(i);
         [t1,FEH]=BLN(TKodeZB,XX(z,3),XX(z,4),0,GUI,FEH);
      if XX(z,2) t2=[T_23 char(TSN(XX(z,2),ITS))]; else t2=T_24; end %ZIT>0 SS_Pfad
         text{end+1,1}=['   ' t1 T_25 num2str(XX(z,7)) T_26 num2str(XX(z,6)) t2];
   end
   end
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(3)                   %Schritt 3: KB Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   if ~isempty(KOB)          %KOB-Z.=[QZN ZIT Skode SNr Z_ZIT VKB Vkode1 VarName1]
   vek=XX(:,4);              %Vektor mit den SNr aller Zustandsblcke dieses FUP's
   [i,zei1]=setdiff(vek,KOB(:,6));%Zustnde des FUP FN ohne angeschlossene KB's
   zei=find(XXg(:,5)==TKodeZB); %alle Projekt-Zeilen mit Zustandsblcken (TKode=10)
   [i,zei2]=setdiff(KOB(:,6),XXg(zei,4));%Projekt KB-Blcke nicht an Zustndsausgngn
   if isempty(zei1)&isempty(zei2) if ASCH text=T_31; else text=[]; end
   else                      %FR Prfzwecke: e21=XX(zei1,:), e22=KOB(zei2,:),
     text=[];              %Rcksetzen, da Ausgabeanzahl/-reihenfolge unbekannt!
     if ~isempty(zei1) text{end+1,1}=[T_32 num2str(FN) ':'];
        for i=1:length(zei1) z=zei1(i);
          [t1,FEH]=BLN(TKodeZB,XX(z,3),XX(z,4),0,GUI,FEH);
       if XX(z,2) t2=[T_38 char(TSN(XX(z,2),ITS))]; else t2=T_39; end%ZIT>0 SS_Pfad
          text{end+1,1}=['   ' t1 T_36 num2str(XX(z,6)) T_37 num2str(XX(z,7)) t2];
        end; end
     if ~isempty(zei2) text{end+1,1}=T_35;
        for i=1:length(zei2) z=zei2(i);
            [t1,FEH]=BLN(TKodeKB,KOB(z,3),KOB(z,4),0,GUI,FEH);
            if KOB(z,2) t2=[T_38 char(TSN(KOB(z,2),ITS))];
            else        t2=T_39; end   %ZIT>0 SS_Pfad
         text{end+1,1}=['   ' t1 t2];
         end; end
   end %Ende "~isempty(KOB)"
   else if ASCH text=T_30; end; end %Keine KB-Blcke verwendet
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(4)                   %Schritt 4: FVZ Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   if ~isempty(FEZ)          %FEZ-Z.=[QZN ZIT Skode SNr Z_ZIT VEX FN BBN1 BBN2 ...]
   zei=find(FEZ(:,7)==FN);   %alle FUP-FN-Zeilen mit FVZ-Blcken
   FEZ0=FEZ(zei,:);          %auf FN reduzieren
   if ~isempty(FEZ0)         % FEZ0, zei0 fr 4a
      zei0=find(FEZ0(:,6)==0);%4a:FVZ-Anschlu an EX enable oder nicht(==0)?
      FEZ1=FEZ0; FEZ1(zei0,:)=[]; %nur fehlerfreie Zeilen weiter prfen
      zei1=[];    %4b
      zei1a=[];   %4bSF1:  --> Sonderfall 1 FVZ mit falscher FN (FN existiert)
      zei1b=[];   %4bSF2:  --> Sonderfall 2 FVZ an EX in Normalablauf
      if ~isempty(FEZ1) [ii,j]=size(FEZ1); %Wieviel Blcke ohne zei0-Fehler?
         for i=1:ii           %4b: zei1 --> FN von Nachfolgerzustnden prfen
             zei=find(XX0(:,4)==FEZ1(i,6)&XX0(:,2)==FEZ1(i,5)); %VEX / Z_ZIT
             if length(zei)>1   errordlg(T_91,'Function HauPar.m aborted','modal');
             elseif isempty(zei) zei1a(end+1)=i; %FEZ1, zei1a fr 4bSF1
             elseif ~isempty(find(XXn(:,4)==FEZ1(i,6)&XXn(:,2)==FEZ1(i,5)))
                    zei1b(end+1)=i; %FEZ1, zei1b fr 4bSF2
             else
             zei=find(XX0(:,4)==XX0(zei,10)&XX0(:,2)==XX0(zei,9));%Nach EX ...?
             if isempty(zei)|length(zei)~=1 %Nachf1 eindeutig identifizierbar?
                errordlg(T_92,'Function HauPar.m aborted','modal'); end
             if XX0(zei,5)~=TKodeZB  %Nachfolger kein Zustandsblock (AxZ/PxV)?
                zei=find(XX0(:,4)==XX0(zei,10)&XX0(:,2)==XX0(zei,9));
                if isempty(zei)|length(zei)~=1 %Nachf2 eindeutig identifizierbar?
                   errordlg(T_93,'Function HauPar.m aborted','modal'); end; end
             for j=1:XX0(zei,8)/2 %Parallelverzweigung bei Fehlerbehandlung?
                 if  XX0(zei,7)~=FEZ1(i,7)  %FN von FVZ und Zustand nach EX ~=!
                     zei1(end+1,:)=[i,zei]; %FEZ1, zei1 fr 4b
                 end; end; end; end
         if zzf               %4c: FVZ unmittelbar nach ZF eingesetzt?
            zei=find(XX0(:,4)==XX0(zzf,10)&XX0(:,2)==XX0(zzf,9)); %ZF Nachfolg
            if XX0(zei,5)==TKodeEX x(1,1:2)=[XX0(zei,2) XX0(zei,4)];%[ZIT SNr]laden
            else for j=1:XX0(zei,8)/2 x(j,1:2)=[XX0(zei,7+2*j) XX0(zei,8+2*j)];end
            end; [ii,j]=size(x); FEZ3=[]; EXO=[];
            FEZ2=FEZ1;                            %fehlerfreie Zeilen weiter prfen
            if ~isempty(zei1) zhi=zei1(:,1); else zhi=[]; end
            zei1su=union(union(zhi,zei1a),zei1b);   %Fehler 4b, 4bSF1 und 4bSF2
            if ~isempty(zei1su) FEZ2(zei1su,:)=[]; end
            for i=1:ii zei=find(FEZ2(:,5)==x(i,1)&FEZ2(:,6)==x(i,2));
                if ~isempty(zei) FEZ2(zei,:)=[]; %unmittelbar nach ZF vorhanden
                else  zei3=find(FEZ(:,5)==x(i,1)&FEZ(:,6)==x(i,2)); %im Projekt?
                   if ~isempty(zei3) FEZ3(end+1,:)=FEZ(zei3,:);  %falsche FN
                   else EXO(end+1,1:2)=[x(i,1) x(i,2)]; end; end %FEH-EX ohne FVZ
            end; end; end; %FEZ2~=[]  -->  entweder nicht unmittelbar nach ZF
                           %               oder falsche FN (FN existiert nicht)!
   if isempty(zei0)&isempty(zei1)&isempty(zei1a)&isempty(zei1b)&isempty(FEZ2)&zzf
      if ASCH text=T_42; else text=[]; end
   else
     if ~zzf text=T_43;      %4d: Kein ZF-Block aber FVZ-Blcke programmiert
     else
       text=[];              %Rcksetzen, da Ausgabeanzahl/-reihenfolge unbekannt!
       if ~isempty(zei0) text{end+1,1}=T_44;            %4a falscher Anschlu
          for i=1:length(zei0) z=zei0(i);
              [t1,FEH]=BLN(TKodeFVZ,FEZ0(z,3),FEZ0(z,4),0,GUI,FEH);
              if FEZ0(z,2) t2=[T_13 char(TSN(FEZ0(z,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end; text{end+1,1}=['   ' t1 t2]; end; end
       if ~isempty(zei1) text{end+1,1}=T_45;            %4b Nachfolg FN falsch
          [jj,j]=size(zei1);                            % zwei Spalten!
          for i=1:jj z=zei1(i,1); z2=zei1(i,2);
              [t1,FEH]=BLN(TKodeFVZ,FEZ1(z,3),FEZ1(z,4),0,GUI,FEH);
              if FEZ1(z,2) t2=[T_13 char(TSN(FEZ1(z,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end;
              [t4,FEH]=BLN(TKodeZB,XX0(z2,3),XX0(z2,4),0,GUI,FEH);
              if XX0(z,2) t5=[T_13 char(TSN(XX0(z2,2),ITS))];%ZIT>0 SS_Pfad
              else        t5=T_14; end;
              t3=[' and ' t4 T_36 num2str(XX0(z2,6)) T_37 num2str(XX0(z2,7)) t5];
              text{end+1,1}=['   ' t1 ' with F' num2str(FN) t2 t3]; end; end
       if ~isempty(zei1a) text{end+1,1}=T_46; %4bS1 FVZ anderer FUP mit falscher FN
          for i=1:length(zei1a) z=zei1a(i);
              [t1,FEH]=BLN(TKodeFVZ,FEZ1(z,3),FEZ1(z,4),0,GUI,FEH);
              if FEZ1(z,2) t2=[T_13 char(TSN(FEZ1(z,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end; text{end+1,1}=['   ' t1 t2]; end; end
       if ~isempty(zei1b) text{end+1,1}=T_47; %4bS2 FVZ an EX in Normalablauf
          for i=1:length(zei1b) z=zei1b(i);
              [t1,FEH]=BLN(TKodeFVZ,FEZ1(z,3),FEZ1(z,4),0,GUI,FEH);
              if FEZ1(z,2) t2=[T_13 char(TSN(FEZ1(z,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end; text{end+1,1}=['   ' t1 t2]; end; end
       if ~isempty(FEZ2) text{end+1,1}=T_48;  %4c FVZ nicht unmittelbar nach ZF
          [zei2,i]=size(FEZ2);
          for i=1:zei2                        %alle Zeilen in FEZ2
              [t1,FEH]=BLN(TKodeFVZ,FEZ2(i,3),FEZ2(i,4),0,GUI,FEH);
              if FEZ2(i,2) t2=[T_13 char(TSN(FEZ2(i,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end; text{end+1,1}=['   ' t1 t2]; end; end
       if ~isempty(FEZ3) text{end+1,1}=T_49;  %4bSF3 FVZ in FUP mit falscher FN
          [zei3,i]=size(FEZ3);
          for i=1:zei3                        %alle Zeilen in FEZ3
              [t1,FEH]=BLN(TKodeFVZ,FEZ3(i,3),FEZ3(i,4),0,GUI,FEH);
              if FEZ3(i,2) t2=[T_13 char(TSN(FEZ3(i,2),ITS))];%ZIT>0 SS_Pfad
              else         t2=T_14; end; text{end+1,1}=['   ' t1 t2]; end; end
       if ~isempty(EXO) text{end+1,1}=T_90;   %4bSF4 EX nach ZF ohne FVZ
          [jj,j]=size(EXO);                            % zwei Spalten!
          for i=1:jj
              [t1,FEH]=BLN(TKodeEX,4892,EXO(i,2),0,GUI,FEH);
              if XX0(z,2) t2=[T_13 char(TSN(EXO(i,1),ITS))];%ZIT>0 SS_Pfad
              else        t2=T_14; end;
              text{end+1,1}=['   ' t1 t2]; end; end
     end
   end
   else if ASCH text=T_41; end; end %Im FUP FN keine FVZ-Blcke verwendet
   else if ASCH text=T_40; end; end %Im Projekt keine FVZ-Blcke verwendet
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(5)                   %Schritt 5: FUV Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   if ~isempty(VAR)          %FEZ-Z.=[QZN ZIT Skode SNr Vkode (Z_ZIT ZSK)]
      KiV0=VAR(:,5); [KiV,z0]=unique(KiV0); %Mit und ohne Wiederholungen
   if ~isempty(KOB)          %Normalfall
      KiK0=KOB(:,7); zei=find(KiK0==0);%reine Kommentarblcke ausblenden
      KiK0(zei)=[]; KiK=unique(KiK0);  %Mit und ohne Wiederholungen
   zei0=setdiff(KiV,KiK);    %Var in FUV's aber nicht in KB's
   zei1=setdiff(KiK,KiV);    %Var in KB's aber nicht in FUV's  
   if isempty(zei0) if ASCH text=T_52; else text=[]; end
      if ASCH     %Ausgabe Anzahl und Namen der Variablen sowie Mehrfachempfang
         LV=length(KiV); text{end+1,1}=[T_53 num2str(LV) T_54];
      for i=1:LV zei=find(VAR(i,:)~=0);      %H1: Anzeige VariablenNamen
          text{end+1,1}=['            ' VAR(z0(i),8:zei(end))]; end
      x=[]; for i=1:length(KiV) j=ismember(KiV0',KiV(i)); x=[x;j]; end;
      x0=sum(x'); zei=find(x0>1); 
      if zei text{end+1,1}=T_56; VL=length(zei);%H2: Mehrfachempfang Variablen
         for i=1:VL z=find(x(zei(i),:)==1); VZ=length(z); t0=VAR(z(1),8:end);
             for j=1:VZ
                 [t1,FEH]=BLN(TKodeFUV,VAR(z(j),3),VAR(z(j),4),0,GUI,FEH);
                 if VAR(z(j),2) t2=[T_13 char(TSN(VAR(z(j),2),ITS))];
                 else t2=T_14; end;
                 text{end+1,1}=['            ' t0 ' ---> ' t1 t2];
             end; end; end; end                 %Ende ASCH-Bedingung
   else
      %text=[];%bedingte Fehler->Rcksetzen, da Ausgabeanz./-reihenfolge unbekannt!
      text={T_55}; LV=length(zei0);
      for i=1:LV z=find(VAR(:,5)==zei0(i)); jj=length(z);
          for j=1:jj  %Schleife fr Sonderfall: FUV/KOB-Fehler*Mehrfachempfang
          [t1,FEH]=BLN(TKodeFUV,VAR(z(j),3),VAR(z(j),4),0,GUI,FEH);
          if VAR(z(j),2) t2=[T_13 char(TSN(VAR(z(j),2),ITS))];else t2=T_14;end%
          text{end+1,1}=['   ' VAR(z(j),8:end) ' ---> ' t1 t2];
          end; end
   end
   else text=T_51; end       %Fataler Fehler: Im Projekt VAR-/aber keine KOB-Blcke
   else if ASCH text=T_50; end; end   %Im Projekt keine VAR-Blcke verwendet
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(6)                   %Schritt 6: VAR in KB Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   if ~isempty(KOB)         %FEZ-Z.=[QZN ZIT Skode SNr Z_ZIT VKB Vkode1 Vkode2 ...]
      KiK0=KOB(:,7);
      zei=find(KiK0==0); KOB(zei)=[]; %reine Kommentarblcke ausblenden
      KiK0(zei)=[]; KiK=unique(KiK0); %Mit und ohne Wiederholungen
   if ~isempty(VAR)          %Normalfall
      KiV0=VAR(:,5); [KiV,z0]=unique(KiV0); %Mit und ohne Wiederholungen
   zei0=setdiff(KiV,KiK);    %Var in FUV's aber nicht in KB's
   zei1=setdiff(KiK,KiV);    %Var in KB's aber nicht in FUV's
   x=[]; for i=1:length(KiV) j=ismember(KiK0',KiV(i)); x=[x;j]; end;x0=sum(x');
   zei3=find(x0==1);         %in KB's nur 1x gesetzte Variablen
   if isempty(zei1)&isempty(zei3) if ASCH text=T_62; else text=[]; end
      if ASCH if ~STEU(5) LV=length(KiV); text{end+1,1}=[T_53 num2str(LV) T_54];
         for i=1:LV zei=find(VAR(i,:)~=0);%Anzeige der VariablenNamen nur einmal!
             text{end+1,1}=['            ' VAR(z0(i),8:zei(end))]; end; end; end
   else
      text=[];%bedingte Fehler->Rcksetzen, da Ausgabeanz./-reihenfolge unbekannt!
      if ~isempty(zei1) text={T_63}; LV=length(zei1);%Var in KB ohne Pendant in FUV
         for i=1:LV z=find(KOB(:,7)==zei1(i)); jj=length(z);
             for j=1:jj [t1,FEH]=BLN(TKodeKB,KOB(z(j),3),KOB(z(j),4),0,GUI,FEH);
               if KOB(z(j),2) t2=[T_13 char(TSN(KOB(z(j),2),ITS))];else t2=T_14;end
                 text{end+1,1}=['   ' KOB(z(j),8:end) ' ---> ' t1 t2];
             end; end; end
      if ~isempty(zei3)
         text{end+1,1}=T_64; VL=length(zei3);        %Wa: nur 1x gesetzte Variablen
         for i=1:VL z=find(x(zei3(i),:)==1); t0=KOB(z,8:end);
             [t1,FEH]=BLN(TKodeKB,KOB(z,3),KOB(z,4),0,GUI,FEH);
             if KOB(z,2) t2=[T_13 char(TSN(KOB(z,2),ITS))]; else t2=T_14; end;
                    text{end+1,1}=['            ' t0 ' ---> ' t1 t2];
         end; end
   end
   else text=T_61; end %Fataler Fehler: Im Projekt KOB-/aber keine VAR-Blcke
   else if ASCH text=T_60; end; end %Im Projekt keine KOB-Blcke verwendet
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if STEU(7)                   %Schritt 7: ZN in FVZ Prfung freigegeben
if ASCH if GUI ANZ(end+1,1)={' '}; else disp(' '); end; end %Eine Zeile Abstand
   if ~isempty(FEZ)          %FEZ-Z.=[QZN ZIT Skode SNr Z_ZIT VEX FN BBN1 BBN2 ...]
   zei=find(FEZ(:,7)==FN);   %alle FUP-FN-Zeilen mit FVZ-Blcken
   FEZ0=FEZ(zei,:);          %auf FN reduzieren
   if ~isempty(FEZ0)
      ZN0=unique(XX0(:,6));  %BN's aller Zustandsblcke dieses FUP's
      zei=find(ZN0(1:end)==0); if ~isempty(zei) ZN0(zei)=[]; end%NichtZustandsBlcke
      ZNn=unique(XXn(:,6));  %BN's aller Normalablauf-Zustandsblcke dieses FUP's
      zei=find(ZNn(1:end)==0); if ~isempty(zei) ZNn(zei)=[]; end%NichtZustandsBlcke
      FEZ0=FEZ0(:,8:end); [ii,j]=size(FEZ0); %BNx ausfiltern / wieviele FVZ-Blcke?
      BG=[]; for i=1:ii BG=union(FEZ0(i,1:j),BG); end; %BN's in Boolschen Gleichngn
      zei=find(BG(1:end)==0);  if ~isempty(zei) BG(zei)=[]; end %BN=0 zum Auffllen
      zei0=setdiff(BG,ZNn);  %Alle ZNn in BG? Ja: zei0=[]!, sonst BG's nicht in ZNn
      zei1=setdiff(ZNn,BG);  %      "          ":    "    , sonst ZNn's nicht in BG
      zei2=setdiff(ZN0,ZNn)'; %alle ZN's von Fehlerbehandlung
      zei3=setdiff(zei0,zei2);%BG's nicht in ZNn und nicht in Fehlerbehandlung
      zei4=intersect(zei0,zei2);%ZN's von Fehlerbehandlung enthalten in BG's
   if isempty(zei0)&isempty(zei1) if ASCH text=T_72; else text=[]; end
      if ASCH         %Ausgabe von Anzahl und Nummern der Fehlerbehandlungszustnde
      L2=length(zei2); Anz=10; AgZ=ceil(L2/Anz); %WerteAnzahl / AnzProZeile / Zei
      text{end+1,1}=[T_73{1,1} num2str(L2) T_73{2,1}];
      for i=1:AgZ x1=1+(i-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end%Anf/End pro Zei
                  text{end+1,1}=['            ' num2str(zei2(x1:x2))]; end; end%Anz
   else
      text=[];                  %Rcksetzen, da Ausgabeanz./-reihenfolge unbekannt!
      if ~isempty(zei1) text{end+1,1}=T_74;   %7a: fehlende ZN von Normalablauf
         L2=length(zei1); Anz=10; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
         for i=1:AgZ x1=1+(i-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end%Anf/EndProZei
                     text{end+1,1}=['   ' num2str(zei1(x1:x2))]; end%Anzeige
      end
      if ~isempty(zei4) text{end+1,1}=T_75;   %7b: falsche ZN von Normalablauf
         L2=length(zei4); Anz=10; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
         for i=1:AgZ x1=1+(i-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end%Anf/EndProZei
                     text{end+1,1}=['   ' num2str(zei4(x1:x2))]; end%Anzeige
      end   
         if ~isempty(zei3) text{end+1,1}=T_76;%7c: falsche nicht existente ZN
         L2=length(zei3); Anz=10; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
         for i=1:AgZ x1=1+(i-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end%Anf/EndProZei
                     text{end+1,1}=['   ' num2str(zei3(x1:x2))]; end%Anzeige
      end   
   end
   else if ASCH text=T_71; end; end %Im FUP FN keine FVZ-Blcke verwendet
   else if ASCH text=T_70; end; end %Im Projekt keine FVZ-Blcke verwendet
   j=length(text); if j if GUI ANZ(end+1:end+j,1)=text(:,1); 
                        else   for i=1:j disp(text{i,1}); end; end; end
end
if GUI if isempty(ANZ)  text=T_01; else text=T_00; end %Markierung: Prfungsende
       j=length(text);  ANZ(end+1:end+j,1)=text(:,1);
else   if isempty(text) text=T_01; else text=T_00; end
       j=length(text);  for i=1:j disp(text{i,1}); end; end
