function [X2,FEH,ANZ]=SYNTAX03(XX,ASCH)
%function [X2,FEH,ANZ]=SYNTAX03(XX,ASCH)
%Syntaxprfung fr Funktionsplne
%X2	: Matrix-Information ber zulssige und unzulssige Blcke
%     [Ausgangszeile  Zielzeile  Ausgangs-SKode  Status(1-i.O.; 2-Fehler)]
%FEH=Cell-String mit Fehlermeldung, wenn ASCH(2)==1 
%ANZ=Cell-String-Vektor mit Ausgabetexten, wenn ASCH(1)==1 & ASCH(2)==1
%XX	: nach FUPSCAN ber XX0 von TundS fr einen Funktionsplan
%ASCH=Textausgabeschalter ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
%                         ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

X2=[]; ZulNB=[];			    %Initialisierung der Variablen
nZulBear = []; nZulnBear = [];	%ZulNB     : Zulssig nicht bearbeitet
ZulBear1 = []; ZulnBear1 = [];	%ZulBear1  : Zulssig bearbeitet 
ZulnBear = []; nZulnBear1 = [];	%nZulnBear1: nicht zul. nicht bearbeitet
T_00='SYNTAX: Abort - code of subsequent block not traceable!';
T_01='SYNTAX: Abort - FUP contains none or several ZA blocks!';
T_02='SYNTAX: Abort - incorrect code during trace for subsequent blocks!';
T_03='No grammatical errors detected.';
T_04='SYNTAX: Abort - several ZF blocks detected!';
T_05='SYNTAX: Abort G5 - wrong number x for blocks PxV!';
T_06='SYNTAX: Abort G1 - wrong number x for blocks AxV!';
T_11='Syntax: Fatal error in G1 - no subsequent block!';
T_12='Syntax: Fatal error in G2 - no subsequent block!';
T_13='Syntax: Fatal error in G3 - no subsequent block!';
T_14='Syntax: Fatal error in G4 - no subsequent block!';
T_15='Syntax: Fatal error in G5 - no subsequent block!';
T_16='Syntax: Fatal error in G6 - no subsequent block!';

FEH={}; ANZ={};             %falls keine Rckmeldung erfolgt
if nargin==1                %Ausgabe aller Rckmeldetexte auf
   ASCH=1; GUI=0;           %Bildschirm freigeben
else GUI=ASCH(2); ASCH=ASCH(1); end
XX0=[XX(:,3:4),XX(:,8)/2,XX(:,10:2:end)];
                               %Def.:  [Skode SNr Offset/2 ZSK1 ZSK2 ...]
XX1=[XX(:,2),XX(:,9:2:end-1)]; %Def.:  [ZIT  Z_ZIT1  Z_ZIT2 ...]
WEI_2=1;                        %2. Durchlauf fr ZF
zzf=find(XX0(:,1)==5105);       %ZF suchen
if isempty(zzf) zzf=0; elseif length(zzf)>1 %Anzahl ZF: 0, 1, >1 ?
   if GUI FEH={T_04}; return; else error(T_04); end; end %nur einmal!
% MATRIX X2 INITIALISIEREN fr ZA als Ausgangspunkt
IndexZA=find(XX0(:,1)==4715);		%finde Index des Anfangzustandes
if length(IndexZA)==1			    %==1 falls genau ein ZA existiert
   Nachf=XX0(IndexZA,4); Z_ZIT=XX1(IndexZA,2);	     %ermittle Nachfolger
   NachfIndx = find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT);%suche Nachfolger
   k2=isempty(NachfIndx);		    %bei existenz dieses
   if k2==0				            %bestimme Zulssigkeit des  Nachf.
     if (XX0(NachfIndx,1)==4701)|(XX0(NachfIndx,1)==4779)|...
        (XX0(NachfIndx,1)==6172)|(XX0(NachfIndx,1)==6250)|...
        (XX0(NachfIndx,1)==4892)		%4 Spalte=1 wenn zulssig
        X2(1,:)=[IndexZA,NachfIndx,XX0(IndexZA,1),1];
     else 				            %4 Spalte=2 wenn nicht zulssig
        X2(1,:)=[IndexZA,NachfIndx,XX0(IndexZA,1),2];
     end
   else if GUI FEH={T_00}; return; else error(T_00); end; end %kein Nachfolger
else if GUI FEH={T_01}; return; else error(T_01); end; end %Anzahl ZA: 0 oder >1 !
k=1;                                %Zeilenzhler
while WEI_2                         %uere while-Schleife for ZF
%BERECHNE MATRIX X2=[VorgngerI, NachfolgerI, VorgBlock, Zulssigkeit]
while  (k>0)				        %X2 Aufbau ab 2. Zeile innere ZA-Schleife
  Nachfolger=XX0(X2(k,2),1);		%ermittle Nachfolger
  switch Nachfolger		
    case 4892,                  [X2,ZulnBear,nZulnBear,FEH]=...
                                    GRAMMATIK02(XX0,XX1,X2,k,FEH,GUI);     %EX
    case {6509,4715,5027,5105}, [X2,ZulnBear,nZulnBear,FEH]=...
                                    GRAMMATIK06(XX0,XX1,X2,k,FEH,GUI); %ZX,ZA,ZE,ZF
    case {6172,6250},           [X2,FEH]=...
                                    GRAMMATIK03(XX0,XX1,X2,k,FEH,GUI);     %P2Z,P3Z
    case {5856,5934},           [X2,ZulnBear,nZulnBear,FEH]=...
                                    GRAMMATIK05(XX0,XX1,X2,k,T_05,FEH,GUI);%P2V,P3V
    case {5017,5095},           [X2,FEH]=...
                                    GRAMMATIK04(XX0,XX1,X2,k,FEH,GUI);     %A2Z,A3Z
    case {4701,4779},           [X2,ZulnBear,nZulnBear,FEH]=...
                                    GRAMMATIK01(XX0,XX1,X2,k,T_06,FEH,GUI);%A2V,A3V
    otherwise, if GUI FEH(end+1,1)={T_02}; return; else error(T_02); end
  end 
  ZulnBear1 =[ZulnBear1; ZulnBear];   ZulnBear  =[];  kz=isempty(ZulnBear1) ; 
  nZulnBear1=[nZulnBear1;nZulnBear];  nZulnBear =[];  kn=isempty(nZulnBear1); 
  B1=find(X2(1:(end-1),1)==X2(end,1));kb1=isempty(B1);	%Block schon bearbeitet?
  B2=find(X2(1:(end-1),2)==X2(end,2));kb2=isempty(B2);  %
  if (kb1==0)&(kb2==0)&(B1==B2)&(kz==0)	   %Ja: analysiere noch nicht bearbeitete
     [X2,ZulnBear1]=SUBSTI(X2,k,ZulnBear1);%zulssige und nicht zulssige Blcke
  end
  if (kb1==0)&(kb2==0)&(B1==B2)&(kz==1)&(kn==0)   %Zeile ersetzen?
     [X2,nZulnBear1]=SUBSTI(X2,k,nZulnBear1); end
  if (kb1==0)&(kb2==0)&(B1==B2)&(kz==1)&(kn==1)   %fertig?
     X2(end,:)=[];            %ZA-/ZF-Ende --> letzte Zeile streichen, da doppelt
     if zzf==0
     X3=find(X2(:,4)==2); k3=isempty(X3);
        if k3==0 X2=X2(X3,:);       %X2 mit fehlerhaften Zeilen fr Rckgabe laden
        else     
           if GUI ANZ={T_03};           %variabel nicht ntig (einzige Ausgabe)
           else   disp(T_03); end; end  %X2 komplett lassen - kein Fehler gefunden
     end
     break; end     %break=while-Schleifenende / kein k=k+1, da Zeile gestrichen
 k=k+1;             %weiter, nchste Zeile adressieren
end                        %Ende innere ZA while-Schleife
% MATRIX X2 INITIALISIEREN fr ZF als Ausgangspunkt
if zzf~=0
   Nachf=XX0(zzf,4); Z_ZIT=XX1(zzf,2);			    %ermittle Nachfolger
   NachfIndx=find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT); %suche Nachfolger
   k2=isempty(NachfIndx);		    %bei existenz dieses
   if k2==0				            %bestimme Zulssigkeit des  Nachf.
     if (XX0(NachfIndx,1)==4701)|(XX0(NachfIndx,1)==4779)|...
        (XX0(NachfIndx,1)==6172)|(XX0(NachfIndx,1)==6250)|...
        (XX0(NachfIndx,1)==4892)	%4 Spalte=1 wenn zulssig
        X2(k+1,:)=[zzf,NachfIndx,XX0(zzf,1),1];
     else 				            %4 Spalte=2 wenn nicht zulssig
        X2(k+1,:)=[zzf,NachfIndx,XX0(zzf,1),2];
     end
     k=k+1;
   else if GUI FEH(end+1,1)={T_00}; return; 
        else error(T_00); end; end %Kein Nachfolger
   zzf=0;
else WEI_2=0; end          %Kein ZF oder ZF schon bearbeitet --> Programmende
end                        %Ende uere ZF while-Schleife


function [X2,ZulNB]=SUBSTI(X2,k,ZulNB)
% function [X2,ZulNB]=SUBSTI(X2,k,ZulNB)
% 
% Ersetzt eine Zeile fr eine andere in der Matrix X2
% falls der zu analysierende Block schon bearbeitet wurde
ZulNB1=[];
ZulNB1=ZulNB;
[M1,N1]=size(ZulNB1);
X2(k+1,:)=ZulNB1(M1,:);
ZulNB= ZulNB1(1:(M1-1),:);

function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK01(XX0,XX1,X2,k,T_06,FEH,GUI,T_11)
%function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK01(XX0,XX1,X2,k,T_06,FEH,GUI,T_11)
% Grammatik von A2V, A3V
% XX0,XX1 : von XX extrahierte Matrizen
% X2	  : Eingang -> Vektor des Vorgngers
% X2	  : Ausgang -> Vektor des Nachfolgers
ZulnBear=[];nZulnBear=[];
Ind=X2(k,2); OffsetNr=XX0(Ind,3);
if OffsetNr>1
   Nachfolgern(1,:)=XX0(Ind,4:end); Nachfolgern(2,:)=XX1(Ind,2:end);%Kode+ZIT
else if GUI FEH(end+1,1)={T_06}; % Absturz verhinderbar ??
            Nachfolgern(1,1)=XX0(Ind,4); Nachfolgern(2,1)=XX1(Ind,2);
     else error(T_06); end; end    %Fataler Fehler
for i=1:OffsetNr
  NachfIndx = find(XX0(:,2)==Nachfolgern(1,i)&XX1(:,1)==Nachfolgern(2,i));
  if ~isempty(NachfIndx)
    if (XX0(NachfIndx,1)==4892)
       if (i~=1) 
          ZulnBear=[ZulnBear;Ind,NachfIndx,XX0(Ind,1),1];
       else
          X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
       end
    else
       if (i~=1)
          nZulnBear=[nZulnBear;Ind,NachfIndx,XX0(Ind,1),2];
       else
          X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
       end
    end
  else          %Fataler Fehler: kein Nachfolger!
    if GUI FEH(end+1,1)={T_11}; else error(T_11); end;
  end 
end

function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK02(XX0,XX1,X2,k,FEH,GUI,T_12)
%function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK02(XX0,XX1,X2,k,FEH,GUI,T_12)
% Grammatik des Ereignisblocks EX, ermittelt Nachfolger und Zulssigkeit
% XX0,XX1 : von XX extrahierte Matrizen
% X2	  : Eingang -> Vektor des Vorgngers
% X2	  : Ausgang -> Vektor des Nachfolgers
% k	      : aktuelle Zeilennummer
ZulnBear=[]; nZulnBear=[];
Ind=X2(k,2); OffsetNr=XX0(Ind,3);
if OffsetNr>1       %Fataler Fehler: Zustand verzweigt direkt ohne AxV
   Nachfolgern(1,:)=XX0(Ind,4:end); Nachfolgern(2,:)=XX1(Ind,2:end);%Kode+ZIT
   for i=1:OffsetNr
      NachfIndx = find(XX0(:,2)==Nachfolgern(1,i)&XX1(:,1)==Nachfolgern(2,i));
      if i~=1
         nZulnBear=[nZulnBear;Ind,NachfIndx,XX0(Ind,1),2];
      else
         X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
      end
   end
else                %Normalfall
Nachf=XX0(Ind,4); Z_ZIT=XX1(Ind,2);
NachfIndx = find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT);
if ~isempty(NachfIndx)
  if    X2(k,3)==4779|X2(k,3)==4701                    %A2V / A3V    
     if XX0(NachfIndx,1)==6509|XX0(NachfIndx,1)==4715|...
        XX0(NachfIndx,1)==5027|XX0(NachfIndx,1)==5105|...
        XX0(NachfIndx,1)==5017|XX0(NachfIndx,1)==5095  %Sonderfall: A2Z / A3Z
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
     else
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
     end
  elseif X2(k,3)==6172|X2(k,3)==6250                   %P2Z / P3Z
     if XX0(NachfIndx,1)==6509|XX0(NachfIndx,1)==4715|...
        XX0(NachfIndx,1)==5027|XX0(NachfIndx,1)==5105
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
     else
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
     end
  elseif X2(k,3)==6509|X2(k,3)==4715|X2(k,3)==5027|X2(k,3)==5105|...
         X2(k,4)==2        %oder schon fehlerhaft zu diesem EX-Block hingeschalten?
     if XX0(NachfIndx,1)==6509|XX0(NachfIndx,1)==5934|XX0(NachfIndx,1)==4715|...
        XX0(NachfIndx,1)==5095|XX0(NachfIndx,1)==5017|XX0(NachfIndx,1)==5856|...
        XX0(NachfIndx,1)==5027|XX0(NachfIndx,1)==5105
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];%(X2(k,4)==2)-> prinzipiell mglich!
     else
        X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];%(X2(k,4)==2)->grundstzlich falsch!
     end
  end
else          %Fataler Fehler G2: kein Nachfolger!
  if GUI FEH(end+1,1)={T_12}; else error(T_12); end;
end     % "k2==0"
end     % "if OffsetNr>1"

function [X2,FEH]=GRAMMATIK03(XX0,XX1,X2,k,FEH,GUI,T_13)
%function [X2,FEH]=GRAMMATIK03(XX0,XX1,X2,k,FEH,GUI,T_13)
% Grammatik von P2Z und P3Z, ermittelt Nachfolger und Zulssigkeit
% XX0,XX1 : von XX extrahierte Matrizen
% X2	  : Eingang -> Vektor des Vorgngers
% X2	  : Ausgang -> Vektor des Nachfolgers

Ind=X2(k,2); Nachf=XX0(Ind,4); Z_ZIT=XX1(Ind,2);
NachfIndx = find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT);
if ~isempty(NachfIndx)
  if (XX0(NachfIndx,1)==4892)
     X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
  else
     X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
   end
else          %Fataler Fehler: kein Nachfolger!
  if GUI FEH(end+1,1)={T_13}; else error(T_13); end;
end

function [X2,FEH]=GRAMMATIK04(XX0,XX1,X2,k,FEH,GUI,T_14)
%function [X2,FEH]=GRAMMATIK04(XX0,XX1,X2,k,FEH,GUI,T_14)
% Grammatik von A2Z und A3Z, ermittelt Nachfolger und Zulssigkeit
% XX0,XX1 : von XX extrahierte Matrizen
% X2	  : Eingang -> Vektor des Vorgngers
% X2	  : Ausgang -> Vektor des Nachfolgers
% k	      : aktuelle Zeile der Matrix X2

%if ((X2((k-1),3)~=6509)&(X2((k-1),3)~=4715)&...
%    (X2((k-1),3)~=5027)&(X2((k-1),3)~=5105))|(X2(k,3)~=4892) %Vorgnger zulssig?
%   X2((k-1):k,4)=2;
%end

Ind=X2(k,2); Nachf=XX0(Ind,4); Z_ZIT=XX1(Ind,2);
NachfIndx = find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT);
if ~isempty(NachfIndx)
  if (XX0(NachfIndx,1)==4715)|(XX0(NachfIndx,1)==6509)|(XX0(NachfIndx,1)==5027)|...
     (XX0(NachfIndx,1)==5105)
     X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
  else
     X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
  end
else          %Fataler Fehler G4: kein Nachfolger!
  if GUI FEH(end+1,1)={T_14}; else error(T_14); end;
end

function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK05(XX0,XX1,X2,k,T_05,FEH,GUI,T_15)
%function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK05(XX0,XX1,X2,k,T_05,FEH,GUI,T_15)
% Grammatik von P2V, P3V, ermittelt Nachfolger und Zulssigkeit
% XX0,XX1  : von XX extrahierte Matrizen
% X2	   : Eingang -> Vektor des Vorgngers
%	     X2=[Index,Ind,XX0(Index,1),1]
%	     X2=[IndexVorg,IndexNach,Code_Vor,Code1]
% 	     Code1: 0 -> nichtbearbeitet
%	       	    1 -> zulssig bearbeitet
%		    2 -> nicht zulssig bearbeitet
% X2	   : Ausgang -> Vektor des Nachfolgers
% ZulnBear : Matrix der zulssig noch nicht bearbeiteten Blcke
% nZulnBear: Matrix der nicht zulssig noch nicht bearbeiteten Blcke

%if ((X2((k-1),3)~=6509)&(X2((k-1),3)~=4715)&...
%    (X2((k-1),3)~=5027)&(X2((k-1),3)~=5105))|(X2(k,3)~=4892) %Vorgnger zulssig?
%   X2((k-1):k,4)=2;
%end
nZulnBear=[]; ZulnBear=[];
Ind=X2(k,2);  OffsetNr=XX0(Ind,3);
if OffsetNr>1
   Nachfolgern(1,:)=XX0(Ind,4:end);      %Kode der Pfade speichern
   Nachfolgern(2,:)=XX1(Ind,2:end);      %ZIT
else if GUI FEH(end+1,1)={T_05};         % Absturz verhinderbar??
            Nachfolgern(1,1)=XX0(Ind,4); Nachfolgern(2,1)=XX1(Ind,2);
     else error(T_05); end; end %Fataler Fehler
for i=1:OffsetNr
  NachfIndx = find(XX0(:,2)==Nachfolgern(1,i)&XX1(:,1)==Nachfolgern(2,i));
  if ~isempty(NachfIndx)							
     if (XX0(NachfIndx,1)==5105)|(XX0(NachfIndx,1)==5027)|...
        (XX0(NachfIndx,1)==6509)|(XX0(NachfIndx,1)==4715)
        if (i~=1) 
           ZulnBear=[ZulnBear;Ind,NachfIndx,XX0(Ind,1),1];
        else
           X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
        end
     else
        if (i~=1) 
           nZulnBear=[nZulnBear;Ind,NachfIndx,XX0(Ind,1),2];
        else
           X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
        end
    end
  else          %Fataler Fehler G5: kein Nachfolger!
      if GUI FEH(end+1,1)={T_15}; else error(T_15); end;
  end 
end 

function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK06(XX0,XX1,X2,k,FEH,GUI,T_16)
%function [X2,ZulnBear,nZulnBear,FEH]=GRAMMATIK06(XX0,XX1,X2,k,FEH,GUI,T_16)
% Suche des Nachfolgers von Zustandsblcken: ZX, ZA, ZE, ZF
% XX0,XX1 : von XX extrahierte Matrizen
% X2	  : Eingang -> Vektor des Vorgngers
%	 X2=[Index,Ind,XX0(Index,1),1]
%	 X2=[IndexVorg,IndexNach,Code_Vor,Code1]
% 	 Code1: 0 -> nichtbearbeitet
%	       	1 -> zulssig bearbeitet
%		    2 -> nicht zulssig bearbeitet
% X2	  : Ausgang -> Vektor des Nachfolgers
ZulnBear=[]; nZulnBear=[];
Ind=X2(k,2); OffsetNr=XX0(Ind,3);
if OffsetNr>1    %Fataler Fehler: Zustand verzweigt direkt ohne PxV
   Nachfolgern(1,:)=XX0(Ind,4:end); Nachfolgern(2,:)=XX1(Ind,2:end);%Kode+ZIT
   for i=1:OffsetNr
      NachfIndx = find(XX0(:,2)==Nachfolgern(1,i)&XX1(:,1)==Nachfolgern(2,i));
      if i~=1
         nZulnBear=[nZulnBear;Ind,NachfIndx,XX0(Ind,1),2];
      else
         X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
      end
   end
else             %Normalfall
   Nachf=XX0(Ind,4); Z_ZIT=XX1(Ind,2);
   NachfIndx = find(XX0(:,2)==Nachf&XX1(:,1)==Z_ZIT);
   if ~isempty(NachfIndx)
      if (XX0(NachfIndx,1)==4701)|(XX0(NachfIndx,1)==4779)|...
         (XX0(NachfIndx,1)==6172)|(XX0(NachfIndx,1)==6250)|...
         (XX0(NachfIndx,1)==4892)
         X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),1];
      else 
         X2(k+1,:)=[Ind,NachfIndx,XX0(Ind,1),2];
      end   
   else          %Fataler Fehler: G6 kein Nachfolger!
      if GUI FEH(end+1,1)={T_16}; else error(T_16); end;
   end
end