function [XX,KOB,VAR,FEZ]=TS_Scan(XX,KOB,VAR,FEZ,VTS)
%Function [XX,KOB,VAR,FEZ]=TS_Scan(XX,KOB,VAR,FEZ,VTS)
%Erweiterung der Matrizen XX,KOB,VAR und FEZ um Verbindungen zu Teilsystemen
%ACHTUNG: die Zielkode-Speicherung ist im Vergleich zu FUPSCAN01/02 verschoben
%Aufruf in Funktion FUPSCAN ab Version 3

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_01='Destination block search ambiguous';
T_02='Destination port search ambiguous';
T_03='Destination ZIT search ambiguous';
T_04='Src: SCH incorrect';
KB=3638;

x=find(VTS(:,1)==0);                    %Zeilen mit "Line: FUP-Block ---> TS-Block"
for i=1:length(x)
   AkZe=x(i);                           %aktuelle Zeile
   SCH=VTS(AkZe,6);                     %FUP Matrix-Auswahl
   ZEILE=VTS(AkZe,3);
   SPALTE=VTS(AkZe,4);
   TKode=VTS(AkZe,7);                   %erste Weiterschaltung des FUP-Blocks
   TK_alt=0;                            %Vorhergehender TKode
   while TKode>0&TKode<1000
      if TK_alt==100 ZIT=VTS(AkZe,3); else ZIT=VTS(AkZe,2); end
      SNr=VTS(AkZe,8);
      Port=VTS(AkZe,9);
      switch TKode
         case 102                      %TKode=102: ?-Block ---> Outport-Block
            VGZ=2;
            AkZe=find(VTS(:,VGZ)==ZIT&VTS(:,4)==TKode&VTS(:,5)==SNr);
            if length(AkZe)~=1 AkZe, error(T_02); end
            Port=VTS(AkZe,6);          %Von TS-Block-Definition angelegte Zeile
            TKode=100;
            AkZe=find(VTS(:,VGZ)==ZIT&VTS(:,4)==TKode&VTS(:,6)==Port);
            TK_alt=TKode;
         case 103                      %TKode=103: ?-Block ---> TS-Ein-Block
            VGZ=3;
           AkZe=find(VTS(:,VGZ)==ZIT&VTS(:,4)==TKode&VTS(:,5)==SNr&VTS(:,6)==Port);
            if length(AkZe)~=1 AkZe, error(T_03); end
            ZIT=VTS(AkZe,2);           %Von TS-Block-Definition angelegte Zeile
            TKode=101;
            VGZ=2;                     %ZIT in der TS selbst programmiert ist
            AkZe=find(VTS(:,VGZ)==ZIT&VTS(:,4)==TKode&VTS(:,6)==Port);
            TK_alt=TKode;
      end
      %AkZe=find(VTS(:,VGZ)==ZIT&VTS(:,4)==TKode&VTS(:,5)==SNr&VTS(:,6)==Port),
      if length(AkZe)~=1 AkZe, error(T_01); end
      TKode=VTS(AkZe,7);
   end                                  %Ziel FUP-Block gefunden
   if TK_alt==100 Z_ZIT=VTS(AkZe,3); else Z_ZIT=VTS(AkZe,2); end
   %SNr=VTS(AkZe,8); %QZN=VTS(AkZe,1);   %Fr Fehlersuche
   %[SCH ZEILE SPALTE SNr Z_ZIT QZN]     %Ergebnisse: noch SPEICHERN
   switch SCH
      case 1                              %XX-FUP-Schaltmatrix laden
         SPALTE=XX(ZEILE,8);              %Neuladen wegem Mehrfachzugriff ntig
         XX(ZEILE,9+SPALTE)=Z_ZIT;        %Ziel-ZIT; wegen Teilsystemen ntig
         XX(ZEILE,10+SPALTE)=VTS(AkZe,8); %Dst-SNr ber Offset speichern
         SPALTE=SPALTE+2;                 %Offset erhhen
         XX(ZEILE,8)=SPALTE;              %Offset speichern
      case 2                              %VAR-Steuervariablenmatrix laden
         VAR(ZEILE,SPALTE)=Z_ZIT;
         VAR(ZEILE,SPALTE+1)=VTS(AkZe,8);
      case 3                              %FEZ-Matrix mit FVZ-Blockinformationen
         if VTS(AkZe,9)==99               %Ziel EX "eanble Port"?
            FEZ(ZEILE,SPALTE)=Z_ZIT;
            FEZ(ZEILE,SPALTE+1)=VTS(AkZe,8);        
         end
      otherwise
         if   TKode==KB
              KOB(ZEILE,SPALTE)=VTS(x(i),2);   %Src-ZIT;
              KOB(ZEILE,SPALTE+1)=VTS(x(i),5); %Src-SNr
         else VTS(x(i),:), error(T_04); end
   end
end
