%Script for loop check regarding missing or just one ZA (or ZE) and ZF
%Skript zum Test auf Rckfhrschleifen ohne ZA oder ZE bzw. ZA

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_01='Input a Function Chart filename including extension: ';
T_01a='s';            %Input as a string!
T_01b='No support for slx model coding in this version.';
T_01c='Please input any *.mdl file name (including extension).';
T_02='Hint: file contains just one Function Chart using FN = ';
T_03='File contains several Function Charts using FN = {';
T_03a='}';
T_04='Choose one Function Chart number: FN = ';
T_05='Operating error: unvalid FN number!';
T_06a='Function Chart ';
T_06b=' consists of all in all ';
T_06c=' state blocks {ZA, ZX, ZE, ZF}';
T_07a='including initial state block ZA = ';
T_07b=' and error state block ZF = ';
T_08='Consolidated error output only(0) / all return information(enter/any)? = ';
T_09a='All in all ';
T_09b=' normal sequence and ';
T_09c=' error sequence loops detected.';
T_10={'Detected normal sequence loops all in all:'};
T_11={'Detected error sequence loops all in all:'};

ASCH=[1 1 1];%ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
             %ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
             %                 oder hier: Reihenfolgevertauschung
             %ASCH(3): 1-Abbruch bei 1.Sackgasse; bel.-alle finden
             %SKO nur fr TEST_RS; FEH,ANZ nur bei Aufruf aus GUI
%Eingabe des FUP-Filenamens einschliesslich Endung, aber ohne "'"
FiNa=input(T_01,T_01a);               %FiNa mit Endung wegen HauPar in TEST_PARA
[path,Filename,Ext]=fileparts(FiNa);  %Filename ohne Endung fuer FUPSCAN
x=input(T_08);                        %Ausgabeumfang der Ausgabe (alles/nurFehler?)
if ~isempty(x)&x==0 ASCH(1)=0; end
if     strcmp(Ext,'.mdl')
       XX=FUPSCAN05(Filename);         %[XX,KOB,VAR,FEZ,ITS]=FUPSCAN05(Filename)
elseif strcmp(Ext,'.slx')  
       errordlg(T_01b,'Abort: script TEST_PARA','modal'); return;
else   errordlg(T_01c,'Abort: script TEST_PARA','modal'); return; end
AnzFN=setdiff(XX(:,7),0)'; %XX_Spalte_7=FN; jede FN nur einmal laden und 
                           %FN=0 von Nichtzustandsblcken ausschlieen
if length(AnzFN)==1
   if ASCH(1) disp([char(09) T_02 int2str(AnzFN)]); end
   FN=AnzFN;
else
   if ASCH(1) disp([char(09) T_03 int2str(AnzFN) T_03a]); end
   FN=input(T_04);
   if isempty(intersect(AnzFN,FN)) error(T_05); end
end
[M,NAZ,NAF,ZOV,SKO,FEH,ANZ1]=XX2M04(XX,FN,ASCH);
if isempty(FEH)
  SBN=length(ZOV);
  if ASCH(1)
     disp([char(09) T_06a int2str(FN) T_06b int2str(SBN) T_06c]);
     if NAF==0
        disp([char(09) T_07a int2str(ZOV(NAZ))]);
     else
        disp([char(09) T_07a int2str(ZOV(NAZ)) T_07b int2str(ZOV(NAF))]);
     end; end
  [PFM1,E1,PFM2,E2,FEH,ANZ2]=TEDERU02(M,NAZ,NAF,ZOV,SKO,ASCH);
  if isempty(FEH)
    ANZ={};                 %Reihenfolgetausch ermglichen
    if ASCH(1)              %Anzeige aller gefundenen Rckfhrschleifen
       jn=length(E1); jf=length(E2);
       ANZ(1,1)={[T_09a num2str(jn) T_09b num2str(jf) T_09c]};
       ANZ(2,1)=T_10;
       for i=1:jn
           E=find(PFM1(i,:)~=0);
           L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
           for ii=1:AgZ
               x1=1+(ii-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end %Anf/EndProZeile
               if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
               ANZ(end+1,1)={[t0 num2str(PFM1(i,x1:x2))]}; end; end %Anzeige
       if jf ANZ(end+1,1)=T_11; end
       for i=1:jf
           E=find(PFM2(i,:)~=0);
           L2=length(E); Anz=15; AgZ=ceil(L2/Anz);%WerteAnzahl/AnzProZeile/Zeilen
           for ii=1:AgZ
               x1=1+(ii-1)*Anz; x2=x1+Anz-1; if x2>L2 x2=L2; end %Anf/EndProZeile
               if x1==1 t0='  -->'; else t0='     '; end;      %Zeilenverlngerung?
               ANZ(end+1,1)={[t0 num2str(PFM2(i,x1:x2))]}; end; end %Anzeige
    end
    ANZ=[ANZ1; ANZ; ANZ2];   %Reihenfolge Hinweis/Anzeige und Warnung/Fehler ndern
    if ~isempty(ANZ) LA=length(ANZ); for i=1:LA disp(ANZ{i,1}); end; end
  else errordlg(FEH,'Function TEDERU aborted','modal'); end %TEDERU mit Fehler abg.
else errordlg(FEH,'Function XX2M aborted','modal'); end%XX2M mit Fehler abgebrochen
