function [FEH,ANZ]=SFDEKO01(X2,XX0,ITS,ASCH)
%function [FEH,ANZ]=SFDEKO01(X2,XX0,ITS,ASCH)
%Klartextausgabe der von SYNTAX ermittelten Syntaxfehler
%FEH=Cell-String mit Fehlermeldung, wenn ASCH(2)==1 
%ANZ=Cell-String-Vektor mit Ausgabetexten, wenn (hier!) ASCH(2)==1
%X2  :Ergebnis von SYNTAX
%XX0 :Ergebnis von TundS aus XX
%ITS :Ergebnis von FUPSCAN
%ASCH=Textausgabeschalter ASCH(1)==ASCH: 1-alle Texte ausgeben; 0-nur Fehler
%                         ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
%                         ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
%                         ASCH(4)==FoS:  1-FUP-Ausgabe(ZN,FN); 0-SIMULINK-Name

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

%XX-XX0-[QZN ZIT Skode SNr Tkode BN FN Offset Z_ZIT1 ZSK1 ...]
%>>>Skode<<<
% ZA=4715;  ZX=6509;  ZE=5027;  ZF=5105;  EX=4892;  KB=3638;  FUV=7816; FVZ=8210;
% A2V=4701; A3V=4779; A2Z=5017; A3Z=5095; P2V=5856; P3V=5934; P2Z=6172; P3Z=6250;
%>>>TKode<<<
% 10-Zustand;    50-Parallel;             20-Kommentar;  30-Fehlervorzustand
% 40-Alternativ; 80-Ereignis;             25-Variablen;
T_0a='SFDEKO: Fatal error --> source >>>and<<< destination code incorrect!';
T_0b='X2-SyntaxCheck=';
T_0c='XX0-output=';
T_0d='XX0-destination=';
T_2a=' in: ';
T_2b=' in: level 0';

FEH={}; ANZ={};           %Initialisierung
if nargin==3              %Ausgabe alle Rckmeldetexte auf
   ASCH=1; GUI=0; FoS=1;  %Bildschirm mit FUP-Ausgabe(BN,FN) freigeben
else GUI=ASCH(2); FoS=ASCH(4); ASCH=ASCH(1); end
[FeZei,j]=size(X2);       %Anzahl der Fehlermeldungen in X2
ANZ={['Please note - ' num2str(FeZei) ' incorrect connection(s) detected:']};
for i=1:FeZei
    A=XX0(X2(i,1),:); Z=XX0(X2(i,2),:); AB=A(5); ZB=Z(5); ZITA=A(2); ZITZ=Z(2);
    if ZITA t1=[T_2a char(TSN(ZITA,ITS))]; else t1=T_2b; end %ZIT>0 SS_Pfad
    if ZITZ t2=[T_2a char(TSN(ZITZ,ITS))]; else t2=T_2b; end %ZIT>0 SS_Pfad
  switch (AB*100+ZB) %Schalten ber TKode-Paar: Ausgangsblocktyp-Zielblocktyp
     case {1010},                  %Zustand --> Zustand
       [n1,FEH]=BLN(A(5),A(3),A(4),FoS,GUI,FEH);
       [n2,FEH]=BLN(Z(5),Z(3),Z(4),FoS,GUI,FEH);
       if FoS e1=['-type using F' num2str(A(7)) '/X' num2str(A(6))];
       else e1=[]; end
       if FoS e2=['-type using F' num2str(Z(7)) '/X' num2str(Z(6))];
       else e2=[]; end
       ANZ{end+1,1}=[num2str(i) '. from state ' n1 e1 t1];
       ANZ{end+1,1}=[          '   to state ' n2 e2 t2];
     case {1080,1040,1050},         %Zustand --> {Ereignis,alternativ,parallel}
       [n1,FEH]=BLN(A(5),A(3),A(4),FoS,GUI,FEH);
       [n2,FEH]=BLN(Z(5),Z(3),Z(4),FoS,GUI,FEH);
       if FoS e1=['-type using F' num2str(A(7)) '/X' num2str(A(6))];
              ANZ{end+1,1}=[num2str(i) '. from state ' n1 e1 t1];
              ANZ{end+1,1}=[          '   to block type ' n2    t2];
       else   ANZ{end+1,1}=[num2str(i) '. from state ' n1    t1];
              ANZ{end+1,1}=[          '   to block ' n2    t2]; end
     case {8010,4010,5010}, %{Ereignis,alternativ,parallel} --> Zustand
       [n1,FEH]=BLN(A(5),A(3),A(4),FoS,GUI,FEH);
       [n2,FEH]=BLN(Z(5),Z(3),Z(4),FoS,GUI,FEH);
       if FoS e2=['-type using F' num2str(Z(7)) '/X' num2str(Z(6))];
              ANZ{end+1,1}=[num2str(i) '. from block type ' n1    t1];
              ANZ{end+1,1}=[          '   to state ' n2 e2 t2];
        else  ANZ{end+1,1}=[num2str(i) '. from block ' n1    t1];
              ANZ{end+1,1}=[          '   to state ' n2    t2]; end
     case {8080,8040,8050,4040,4050,4080,5050,5040,5080} %Restkombinationen
       [n1,FEH]=BLN(A(5),A(3),A(4),FoS,GUI,FEH);
       [n2,FEH]=BLN(Z(5),Z(3),Z(4),FoS,GUI,FEH);
       if FoS ANZ{end+1,1}=[num2str(i) '. from block type ' n1    t1];
              ANZ{end+1,1}=[          '   to block type ' n2    t2];
       else   ANZ{end+1,1}=[num2str(i) '. from block ' n1    t1];
              ANZ{end+1,1}=[          '   to block ' n2    t2]; end
   otherwise
       if     AB==10|AB==80|AB==40|AB==50 %Zielkode fehlerhaft
         [n1,FEH]=BLN(A(5),A(3),A(4),FoS,GUI,FEH); n2='???';
         if FoS if AB==10 e1=[' F' num2str(A(7)) '/X' num2str(A(6))];
                          ANZ{end+1,1}=[num2str(i) '. from state ' n1 e1 t1];
                else      ANZ{end+1,1}=[num2str(i) '. from block type ' n1    t1];
                end
         
         else   if AB==10 ANZ{end+1,1}=[num2str(i) '. from state ' n1    t1];
                else      ANZ{end+1,1}=[num2str(i) '. to block ' n1    t1];
                end; end
         ANZ{end+1,1}=[          '   to ' n2    t2];
         ANZ{end+1,1}=['       incorrect XX-destination=[' num2str(Z) ']'];
       elseif ZB==10|ZB==80|ZB==40|ZB==50 %Ausgangskode fehlerhaft
         n1='???'; [n2,FEH]=BLN(Z(5),Z(3),Z(4),FoS,GUI,FEH);
         ANZ{end+1,1}=[num2str(i) '. from state ' n1    t1];
         ANZ{end+1,1}=['       incorrect XX-output=[' num2str(A) ']'];         
         
         if FoS if ZB==10 e2=[' F' num2str(Z(7)) '/X' num2str(Z(6))];
                          ANZ{end+1,1}=[          '   to state ' n2 e2 t2];
                else      ANZ{end+1,1}=[          '   to block type ' n2    t2];
                end
         else   if ZB==10 ANZ{end+1,1}=[          '   to state ' n2    t2];
                else      ANZ{end+1,1}=[          '   to block ' n2    t2];
                end; end
       else                         % Ausgangs- und Zielkode fehlerhaft
        T_00=[T_0a char(10) T_0b '[' num2str(X2(i,:)) ']'...
                   char(10) T_0c '[' num2str(XX0(X2(i,1),:)) ']'...
                   char(10) T_0d '[' num2str(XX0(X2(i,2),:)) ']'];
        if GUI FEH={T_00}; return; else error(T_00); end; end 
  end
end

