%Script for parameter check / input errors and graphical programming errors
%Skript zum Test der Parameter / Erkennung von Eingabe- und Programmierfehlern

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_01='Input a Function Chart filename including extension: ';
T_01a='s';            %Input as a string!
T_01b='No support for slx model coding in this version.';
T_01c='Please input any *.mdl file name (including extension).';
T_02='Hint: file contains just one Function Chart using FN = ';
T_03='File contains several Function Charts using FN = {';
T_03a='}';
T_04='Choose one Function Chart number: FN = ';
T_05='Operating error - unvalid FN number!';
T_06='Fatal error: selected Function Chart contains not just one ZA block!';
T_07='Hint: selected Function Chart devoid of any ZF block!';
T_08='Fatal error: selected Function Chart contains more then one ZF block!';
T_09a='Choice of checks (enter=all(7); 1-yes/0-no):';
T_09b=' = [FN ZN KB FVZ FUV VARinKB ZNinFVZ]=';
T_09=[T_09a T_09b];
T_10='Operating error - no check selected!';
T_11='Operating error - unvalid check specification!';
T_12='Consolidated error output only(0) / All return information(enter/any)  = ';

ASCH=[1 0 1 0];  %ASCH(1)==ASCH: 1-alle Texte ausgeben; 0-nur Fehler
                 %ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
                 %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                 %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN); 0-SIMULINK-Name
STEU=[1 1 1 1 1 1 1];%STEU(1)=1 FN  Prfung (alle FN im FUP gleich?)
                     %STEU(2)=1 ZN  Prfung (alle ZN im FUP verschieden?)
                     %STEU(3)=1 KB  Prfung (alle KB an Zustandsausgang?)
                     %STEU(4)=1 FVZ Prfung (alle FVZ an EX enable?)
                     %STEU(5)=1 FUV Prfung (alle FUV-Var mit KB Sender?)
                     %STEU(6)=1 VAR in KB Prfung (alle KB-Var mit FUV Empfang?)
                     %STEU(7)=1 ZN in FVZ Prfung (alle Zustandsnummern in FVZ?)
%Eingabe des FUP-Filenamens einschliesslich Endung, aber ohne "'"
FiNa=input(T_01,T_01a);    %FiNa     mit Endung  fuer HauPar
[path,Filename,Ext]=fileparts(FiNa);  %Filename ohne Endung fuer FUPSCAN
if     strcmp(Ext,'.mdl')  [XX,KOB,VAR,FEZ,ITS]=FUPSCAN05(Filename);
elseif strcmp(Ext,'.slx')  
       errordlg(T_01b,'Abort: script TEST_PARA','modal'); return;
else   errordlg(T_01c,'Abort: script TEST_PARA','modal'); return; end
WEI=1;                     %Initialisierung des Weiterschaltens nach Analyse
AnzFN=setdiff(XX(:,7),0)'; %XX_Spalte_7=FN; jede FN nur einmal laden und 
                           %FN=0 von Nichtzustandsblcken ausschlieen  
if length(AnzFN)==1        %File enthlt genau einen FUP
   if ASCH disp([char(09) T_02 int2str(AnzFN)]); end
   FN=AnzFN;
else                       %File enthlt mehrere FUP's
   disp([char(09) T_03 int2str(AnzFN) T_03a]);
   FN=input(T_04);         %Auswahl eines Funktionsplanes
   if isempty(intersect(AnzFN,FN))
      errordlg(T_05,'Abort: script TEST_PARA','modal'); WEI=0; end
end
zza=find(XX(:,3)==4715&XX(:,7)==FN); %Zeile von ZA im ausgewhltem FN suchen
if length(zza)~=1 
   errordlg(T_06,'Abort: script TEST_PARA','modal'); WEI=0; end
zzf=find(XX(:,3)==5105&XX(:,7)==FN); %Zeile von ZF im ausgewhltem FN suchen
i=length(zzf);
if i==0 zzf=0; if ASCH disp([char(09) T_07]); end
elseif i>1  errordlg(T_08,'Abort: script TEST_PARA','modal'); WEI=0; end
x=input(T_09);                                %STEU=?
if isempty(x) x=STEU;
else L=length(x);
    if L==7 STEU=x&STEU;
    else    errordlg(T_11,'Abort: script TEST_PARA','modal'); WEI=0; end; end
if sum(STEU)==0 errordlg(T_10,'Abort: script TEST_PARA','modal'); WEI=0; end
x=input(T_12);                                %Ausgabeumfang
if ~isempty(x)&x==0 ASCH(1)=0; end
if WEI [XX0,FEH,ANZ,XXn]=TundS03(XX,zza,zzf,ITS,ASCH); %liefert Analyse Fehler?
  if isempty(FEH)
    if ~isempty(ANZ) disp(ANZ); end
    if zzf zzf=find(XX0(:,3)==5105); end %Zeile von ZF in XX0 fr FN suchen
    [FEH,ANZ]=HauPar01(XX,XX0,XXn,KOB,VAR,FEZ,ITS,FN,FiNa,zzf,STEU,ASCH);
    if isempty(FEH)
       LA=length(ANZ); for i=1:LA disp(ANZ{i,1}); end
    else errordlg(FEH,'Function HauPar.m aborted','modal'); end %HauPar Fehler abg.
  else errordlg(FEH,'Function TundS.m aborted','modal'); end %TundS mit Fehler abg.
end
