%Script for dead end check %Skript zum Test auf Sackgassen

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_00='This Function Chart features no dead ends.';
T_01='Input a Function Chart filename including extension: ';
T_01a='s';            %Input as a string!
T_01b='No support for slx model coding in this version.';
T_01c='Please input any *.mdl file name (including extension).';
T_02='Hint: file contains just one Function Chart using FN = ';
T_03='File contains several Function Charts using FN = {';
T_03a='}';
T_04='Choose one Function Chart number: FN = ';
T_05='Operating error: unvalid FN number!';
T_06a='Function Chart ';
T_06b=' consists of all in all ';
T_06c=' state blocks {ZA, ZX, ZE, ZF}';
T_07a='including initial state block ZA = ';
T_07b=' and error state block ZF = ';

%Eingabe des FUP-Filenamens einschliesslich Endung, aber ohne "'"
FiNa=input(T_01,T_01a);               %FiNa mit Endung wegen HauPar in TEST_PARA
[path,Filename,Ext]=fileparts(FiNa);  %Filename ohne Endung fuer FUPSCAN
if     strcmp(Ext,'.mdl') 
       XX=FUPSCAN05(Filename);        %[XX,KOB,VAR,FEZ,ITS]=FUPSCAN05(Filename)
elseif strcmp(Ext,'.slx')  
       errordlg(T_01b,'Abort: script TEST_PARA','modal'); return;
else   errordlg(T_01c,'Abort: script TEST_PARA','modal'); return; end
AnzFN=setdiff(XX(:,7),0)'; %XX_Spalte_7=FN; jede FN nur einmal laden und 
                           %FN=0 von Nichtzustandsblcken ausschlieen  
if length(AnzFN)==1
   disp([char(09) T_02 int2str(AnzFN)]);
   FN=AnzFN;
else
   disp([char(09) T_03 int2str(AnzFN) T_03a]);
   FN=input(T_04);
   if isempty(intersect(AnzFN,FN)) error(T_05); end
end
ASCH=[1 0 1];%ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
             %ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
             %ASCH(3): 1-Abbruch bei 1.Sackgasse; bel.-alle finden
             %SKO nur fr TEST_RS; FEH,ANZ nur bei Aufruf aus GUI, deshalb:
[M,NAZ,NAF,ZOV]=XX2M04(XX,FN,ASCH); %Ausgnge: SKO,FEH,ANZ nicht verwendet!
SBN=length(ZOV);
disp([char(09) T_06a int2str(FN) T_06b int2str(SBN) T_06c]);
if NAF==0
   disp([char(09) T_07a int2str(ZOV(NAZ))]);
else
   disp([char(09) T_07a int2str(ZOV(NAZ)) T_07b int2str(ZOV(NAF))]);
end
ZM=sum(M');                                        %Zeilensumme<-1 vorhanden?
if isempty(find(ZM(:)<-1)) disp(T_00); return; end %Keine PxV?
[M,NAZ,NAF,ZOV]=RELIZU03(M,NAZ,NAF,ZOV,ASCH); %ab Version RELIZU02 wegen NAF
[M,NAZ,NAF,ZOV]=ZUKOM03(M,NAZ,NAF,ZOV,ASCH);  %ohne NAZ/NAF nderung
nes=input('Check for first dead end only (input: 1)? = ');
        %('Nur auf erste Sackgasse prfen (Eingabe: 1)? = ');
if isempty(nes) ASCH(3)=0; else ASCH(3)=nes; end
[BBZ,NUZ,SGZ]=TAZUSA06(M,NAZ,NAF,ZOV,ASCH);
