%Script for syntax check %Skript zum Test der Syntax

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_01='Input a Function Chart filename including extension: ';
T_01a='s';            %Input as a string!
T_01b='No support for slx model coding in this version.';
T_01c='Please input any *.mdl file name (including extension).';
T_02='Hint: file contains just one Function Chart using FN = ';
T_03='File contains several Function Charts using FN = {';
T_03a='}';
T_04='Choose one Function Chart number: FN = ';
T_05='Operating error: unvalid FN number!';
T_06='Abort: selected Function Chart contains not just one ZA block!';
T_07='Hint: selected Function Chart devoid of any ZF block!';
T_08='Abort: selected Function Chart contains more then one ZF block!';

%Eingabe des FUP-Filenamens einschliesslich Endung, aber ohne "'"
FiNa=input(T_01,T_01a);               %FiNa mit Endung wegen HauPar in TEST_PARA
[path,Filename,Ext]=fileparts(FiNa);  %Filename ohne Endung fuer FUPSCAN
if     strcmp(Ext,'.mdl')  [XX,KOB,VAR,FEZ,ITS]=FUPSCAN05(Filename);
elseif strcmp(Ext,'.slx')  
       errordlg(T_01b,'Abort: script TEST_PARA','modal'); return;
else   errordlg(T_01c,'Abort: script TEST_PARA','modal'); return; end
AnzFN=setdiff(XX(:,7),0)'; %XX_Spalte_7=FN; jede FN nur einmal laden und 
                           %FN=0 von Nichtzustandsblcken ausschlieen  
if length(AnzFN)==1        %File enthlt genau einen FUP
   disp([char(09) T_02 int2str(AnzFN)]);
   FN=AnzFN;
else                       %File enthlt mehrere FUP's
   disp([char(09) T_03 int2str(AnzFN) T_03a]);
   FN=input(T_04);         %Auswahl eines Funktionsplanes
   if isempty(intersect(AnzFN,FN)) error(T_05); end
end
zza=find(XX(:,3)==4715&XX(:,7)==FN); %Zeile von ZA im ausgewhltem FN suchen
if length(zza)~=1 error(T_06); end
zzf=find(XX(:,3)==5105&XX(:,7)==FN); %Zeile von ZF im ausgewhltem FN suchen
i=length(zzf);
if i==0 zzf=0; disp([char(09) T_07]); elseif i>1  error(T_08); end
ASCH=[1 1 1 0];  %ASCH(1)==ASCH: 1-alle Texte ausgeben; 0-nur Fehler
                 %ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
                 %ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
                 %ASCH(4)==FoS:  1-FUP-Ausgabe(BN,FN); 0-SIMULINK-Name
[XX0,FEH,ANZ]=TundS03(XX,zza,zzf,ITS,ASCH);
if isempty(FEH)
  if ~isempty(ANZ) disp(ANZ); end
  [X2,FEH,ANZ]=SYNTAX03(XX0,ASCH);
  if isempty(FEH)
     if isempty(ANZ)                 %wenn ANZ leer, dann in X2 Verbindungsfehler
        [FEH,ANZ]=SFDEKO01(X2,XX0,ITS,ASCH); %Klartextausgabe der Syntaxfehler
        if isempty(FEH) 
           if ~isempty(ANZ) ii=length(ANZ); 
              for i=1:ii disp(ANZ{i,1}(1,1:end)); end;
           else errordlg('?? SFDEKO: ANZ=0 ??','SFDEKO.m: fatal result!','modal');
           end
        else errordlg(FEH,'Function SFDEKO.m aborted','modal'); end%SFDEKO mit Feh.
     else disp(ANZ); end        %Kein SyntaxFehler gefunden -einzeilige Ausschrift!
  else errordlg(FEH,'Function SYNTAX.m aborted','modal'); end %SYNTAX mit Fehler
else errordlg(FEH,'Function TundS.m aborted','modal'); end %TundS mit Fehler abgeb.
