function [NeueMat0,FEH,ANZ,XXn]=TundS03(XX,index,zzf,ITS,ASCH)
%function [NeueMat0,FEH,ANZ,XXn]=TundS03(XX,index,zzf,ITS,ASCH)
%Bildet aus der Matrix XX in dem Fall das mehrere Funktionsplne in einer
%Datei gespeichert wurden neu Matrizen, diese entsprechen je einem Funktionsplan
%NeueMat0	:entspricht einer MatrixXX sortiert fr >>>einen<<< FUP
%FEH=Cell-String mit Fehlermeldung, wenn ASCH(2)==1 
%ANZ=Cell-String-Vektor mit Ausgabetexten, wenn ASCH(1)==1 & ASCH(2)==1
%XXn        :wie NeueMat0 aber ohne Fehlerbehandlungsablufe
%XX		    :XX Matrix von FUPSCAN
%index		:Zeile von ZA
%zzf        :Zeile von ZF
%ASCH Textausgabeschalter ASCH(1)==ASCH: 0-nur Fehler; 1-alle Texte ausgeben
%                         ASCH(2)==GUI:  1-Textumleitung von Bildschirm in GUI
%                         ASCH(3)==Sackgassenprfung: 1-erste; bel.-alle
%                         ASCH(4)==FoS:  1-FUP-Ausgabe(ZN,FN); 0-SIMULINK-Name
%ACHTUNG!! die Existenz aller Blcke muss gewhrleistet sein.

%  Copyright (c) 1997-2013. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner; TU Dresden, Fak. EuI,
%                     Elektrotechnisches Institut (ETI); Mommsenstr. 13;
%                     D-01062 Dresden, Germany;
%                     http://eeiwzg.et.tu-dresden.de/ae2_files/ae_7_6e.htm

T_00='     missing connection to subsequent blocks!';
T_01=' --> ZA block without subsequent block from FUP library';
T_02=' --> ZF block without subsequent block from FUP library';
T_03a=' --> FUP block';
T_03b='             or';
T_03c='     without subsequent block from FUP library';

FEH={}; ANZ={};             %initialisieren falls keine Rckmeldung erfolgt
if nargin==3                %ohne Vorgabe: Ausgabe aller Rckmeldetexte auf
   ASCH=1; GUI=0; FoS=0;    %Bildschirm freigeben
else GUI=ASCH(2); FoS=ASCH(4); ASCH=ASCH(1); end
WEI=1; XXn=[];              %Mglichkeit eines 2. Laufs fr ZF / nur Normalablauf
XXneu  = [XX(1:index-1,:);XX(index+1:end,:)]; %Neue Natrix XX ohne ausgewhlten ZA
NeueMat= XX(index,:); NeueMat0=NeueMat;       %XX-Zeile fr ZA
                                   %Ermittlung: Nachfolger u. wartende Blcke
if NeueMat(8)==2                      %Offset=2 --> Normalfall: ein Nachfolger
   Nachfolg(1,:)=NeueMat(9:10); wartend=[];
elseif NeueMat(8)>2                   %Offset>2 --> Verzweigung: AxV oder PxV
   Nachfolg(1,:)=NeueMat(9:10);
   for ii=1:NeueMat(8)/2 wartend(ii,:)=NeueMat(9+2*ii:10+2*ii); end
else                                  %Offset=0 --> Fehler: ZA ohne Nachfolger
   wartend=[]; Nachfolg=[];           %                     oder ohne Verbindung
   if GUI FEH(end+1:end+3,1)={T_01;T_03b;T_00}; return;
   else   error([T_01 char(10) T_03b char(10) T_00]); end; end
wartend0=wartend;

while WEI
signal=find(NeueMat(end,4)==Nachfolg(1,2));
k=isempty(signal);k2=isempty(wartend);
while (k==1)					%Auswahl aller Zeilen die zum Fuktionsplan gehren
    z=find(XXneu(:,4)==Nachfolg(1,2));       %Suche nach dem nchsten Block (Zeile) 
    [M,N]=size(z);				%Voraussetzung die NachfolgerNummer stimmmt 
    for i=1:M					%genauso wie die EbenenNummer in ZIT und Z_ZIT
       if (XXneu(z(i,1),2)==Nachfolg(1,1));	 %bei Uebereinstimmung dieser Nummern
         index=z(i,1); 			%Uebergebe den Index in der die Zeile im XXneu sich
       end						%befindet
    end
    NeueMat=XXneu(index,:);			%NeuMat == neu ermttelter Zeile aus XXneu
    NeueMat0=[NeueMat0;NeueMat];	%Bilden von NeuMat0 als Ausgabe-Matrix
                                    %Ermittlung: Nachfolger u. wartende Blcke
    if NeueMat(8)==2                   %Offset=2 --> Normalfall: ein Nachfolger
       Nachfolg(1,:)=NeueMat(9:10); wartend=[];
    elseif NeueMat(8)>2                %Offset>2 --> Verzweigung: AxV oder PxV
       Nachfolg(1,:)=NeueMat(9:10);
       for ii=1:NeueMat(8)/2-1 wartend(ii,:)=NeueMat(9+2*ii:10+2*ii); end
    else                            %Offset=0 --> Fehler: FUP-Block ohne Nachfolger
       wartend=[]; Nachfolg=[];     %                     oder ohne Verbindung
       [B,FEH]=BLN(NeueMat(5),NeueMat(3),NeueMat(4),FoS,GUI,FEH);
       if FoS e1=[' type with F' num2str(NeueMat(7)) '/X' num2str(NeueMat(6))];
       else e1=[]; end
       if NeueMat(2) N=TSN(NeueMat(2),ITS); else N='level 0'; end %ZIT>0 SS_Pfad
       if GUI FEH(end+1:end+4,1)={[T_03a ' ' B e1 ' in: ' N];T_03c;T_03b;T_00};
       else error([T_03a ' ' B ' in: ' ...
                               N char(10) T_03c char(10) T_03b char(10) T_00]);
            end; end
    k=isempty(wartend);			%Falls wartende Nachfolgern existierend.h. k=0
    if k==0						%berpruefe ob diese schon behandelt wurden
       [M0,N0]=size(wartend);	%d.h sie sind schon im "NeuMat0" eingebunden worden
       for x=1:M0				%berpruefe ob der Block schon behandelt wurde
          z=find(NeueMat0(:,4)==wartend(x,2));	
          k0=isempty(z);
          if k0==0
             [M,N]=size(z);
             for i=1:M			%berprfe ob so ein Block in dieser Ebene schon
                if (NeueMat0(z(i,1),2)==wartend(x,1))%existiert in Matrix "XXNeu"  
                   wartend(x,:)=[];	%falls ja, setze den zugehrigen wartend=[]
                end
             end      
          end
       end                          %for Ende
    end
    wartend0=[wartend0;wartend];	%Matrix aller wartenden Nachfolgern

    if isempty(Nachfolg)|~isempty(find(NeueMat0(:,4)==Nachfolg(2)&...
                                       NeueMat0(:,2)==Nachfolg(1)))
         k=0;                    %Nachfolger und zugehrige Ebene schon existent
    else k=1; end				 %eine der Bedingungen ist nicht erfllt
    k2=isempty(wartend0);	     %wartend0 leer?
    if (k==0)&(k2==0)			 %kein Nachfolg (k=0) aber wartende Nachfolg (k2=0)
       WEI2=1;                   %Zeilenvervielfachung ausschlieen fr fehlerhafte
       while WEI2                %Direktverbindungen : AxV --> AxZ; PxV --> PxZ
         Nachfolg=wartend0(1,:); %ist "Nachfolg=wartend"
         k=1;
         wartend0(1,:)=[];        %ausgelesene Nachfolger-Zeile streichen!
         if isempty(find(NeueMat0(:,2)==Nachfolg(1)&NeueMat0(:,4)==Nachfolg(2)))
            WEI2=0;               %Normalfall: Zeile existiert noch nicht   
         else                     %Nachfolger=Sonderfall=weglassen --> Weitere??
            if isempty(wartend0) WEI2=0; k=0; end%kein weiterer Nachfolger vorhandn
         end   
       end
    end                           %k=0&k2=1 --> k=0; k=1&k2=x --> k=1 schon erfllt
end %Ende while innen
  if zzf~=0                   %ZF-Block vorhanden?
  XXn=NeueMat0;               %Normalablauf: fr Test_Para (S. 4e + 7);ohne ZF leer
  NeueMat= XX(zzf,:);         %XX-Zeile fr ZF
  NeueMat0=[NeueMat0;NeueMat];%Ergebnisse von ZA plus Zeile fr ZF
                              %Ermittlung: Nachfolger u. wartende Blcke
  if NeueMat(8)==2                   %Offset=2 --> Normalfall: ein Nachfolger
     Nachfolg(1,:)=NeueMat(9:10); wartend=[];
  elseif NeueMat(8)>2                %Offset>2 --> Verzweigung: AxV oder PxV
     Nachfolg(1,:)=NeueMat(9:10);
     for ii=1:NeueMat(8)/2 wartend(ii,:)=NeueMat(9+2*ii:10+2*ii); end
  else                               %Offset=0 --> Fehler: ZF ohne Nachfolger
     wartend=[]; Nachfolg=[];        %                     oder ohne Verbindung
     if GUI FEH(end+1:end+3,1)={T_02;T_03b;T_00}; return;
     else   error([T_02 char(10) T_03b char(10) T_00]); end; end
  wartend0=wartend;
  zzf=0;
  else WEI=0; if isempty(XXn) XXn=NeueMat0; end; end
end %Ende while auen
